# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['EndpointControlProfileArgs', 'EndpointControlProfile']

@pulumi.input_type
class EndpointControlProfileArgs:
    def __init__(__self__, *,
                 description: Optional[pulumi.Input[str]] = None,
                 device_groups: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileDeviceGroupArgs']]]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 forticlient_android_settings: Optional[pulumi.Input['EndpointControlProfileForticlientAndroidSettingsArgs']] = None,
                 forticlient_ios_settings: Optional[pulumi.Input['EndpointControlProfileForticlientIosSettingsArgs']] = None,
                 forticlient_winmac_settings: Optional[pulumi.Input['EndpointControlProfileForticlientWinmacSettingsArgs']] = None,
                 on_net_addrs: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileOnNetAddrArgs']]]] = None,
                 profile_name: Optional[pulumi.Input[str]] = None,
                 replacemsg_override_group: Optional[pulumi.Input[str]] = None,
                 src_addrs: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileSrcAddrArgs']]]] = None,
                 user_groups: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserGroupArgs']]]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserArgs']]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a EndpointControlProfile resource.
        :param pulumi.Input[str] description: Description.
        :param pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileDeviceGroupArgs']]] device_groups: Device groups. The structure of `device_groups` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input['EndpointControlProfileForticlientAndroidSettingsArgs'] forticlient_android_settings: FortiClient settings for Android platform. The structure of `forticlient_android_settings` block is documented below.
        :param pulumi.Input['EndpointControlProfileForticlientIosSettingsArgs'] forticlient_ios_settings: FortiClient settings for iOS platform. The structure of `forticlient_ios_settings` block is documented below.
        :param pulumi.Input['EndpointControlProfileForticlientWinmacSettingsArgs'] forticlient_winmac_settings: FortiClient settings for Windows/Mac platform. The structure of `forticlient_winmac_settings` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileOnNetAddrArgs']]] on_net_addrs: Addresses for on-net detection. The structure of `on_net_addr` block is documented below.
        :param pulumi.Input[str] profile_name: Profile name.
        :param pulumi.Input[str] replacemsg_override_group: Select an endpoint control replacement message override group from available options.
        :param pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileSrcAddrArgs']]] src_addrs: Source addresses. The structure of `src_addr` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserGroupArgs']]] user_groups: User groups. The structure of `user_groups` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserArgs']]] users: Users. The structure of `users` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if device_groups is not None:
            pulumi.set(__self__, "device_groups", device_groups)
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if forticlient_android_settings is not None:
            pulumi.set(__self__, "forticlient_android_settings", forticlient_android_settings)
        if forticlient_ios_settings is not None:
            pulumi.set(__self__, "forticlient_ios_settings", forticlient_ios_settings)
        if forticlient_winmac_settings is not None:
            pulumi.set(__self__, "forticlient_winmac_settings", forticlient_winmac_settings)
        if on_net_addrs is not None:
            pulumi.set(__self__, "on_net_addrs", on_net_addrs)
        if profile_name is not None:
            pulumi.set(__self__, "profile_name", profile_name)
        if replacemsg_override_group is not None:
            pulumi.set(__self__, "replacemsg_override_group", replacemsg_override_group)
        if src_addrs is not None:
            pulumi.set(__self__, "src_addrs", src_addrs)
        if user_groups is not None:
            pulumi.set(__self__, "user_groups", user_groups)
        if users is not None:
            pulumi.set(__self__, "users", users)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="deviceGroups")
    def device_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileDeviceGroupArgs']]]]:
        """
        Device groups. The structure of `device_groups` block is documented below.
        """
        return pulumi.get(self, "device_groups")

    @device_groups.setter
    def device_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileDeviceGroupArgs']]]]):
        pulumi.set(self, "device_groups", value)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter(name="forticlientAndroidSettings")
    def forticlient_android_settings(self) -> Optional[pulumi.Input['EndpointControlProfileForticlientAndroidSettingsArgs']]:
        """
        FortiClient settings for Android platform. The structure of `forticlient_android_settings` block is documented below.
        """
        return pulumi.get(self, "forticlient_android_settings")

    @forticlient_android_settings.setter
    def forticlient_android_settings(self, value: Optional[pulumi.Input['EndpointControlProfileForticlientAndroidSettingsArgs']]):
        pulumi.set(self, "forticlient_android_settings", value)

    @property
    @pulumi.getter(name="forticlientIosSettings")
    def forticlient_ios_settings(self) -> Optional[pulumi.Input['EndpointControlProfileForticlientIosSettingsArgs']]:
        """
        FortiClient settings for iOS platform. The structure of `forticlient_ios_settings` block is documented below.
        """
        return pulumi.get(self, "forticlient_ios_settings")

    @forticlient_ios_settings.setter
    def forticlient_ios_settings(self, value: Optional[pulumi.Input['EndpointControlProfileForticlientIosSettingsArgs']]):
        pulumi.set(self, "forticlient_ios_settings", value)

    @property
    @pulumi.getter(name="forticlientWinmacSettings")
    def forticlient_winmac_settings(self) -> Optional[pulumi.Input['EndpointControlProfileForticlientWinmacSettingsArgs']]:
        """
        FortiClient settings for Windows/Mac platform. The structure of `forticlient_winmac_settings` block is documented below.
        """
        return pulumi.get(self, "forticlient_winmac_settings")

    @forticlient_winmac_settings.setter
    def forticlient_winmac_settings(self, value: Optional[pulumi.Input['EndpointControlProfileForticlientWinmacSettingsArgs']]):
        pulumi.set(self, "forticlient_winmac_settings", value)

    @property
    @pulumi.getter(name="onNetAddrs")
    def on_net_addrs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileOnNetAddrArgs']]]]:
        """
        Addresses for on-net detection. The structure of `on_net_addr` block is documented below.
        """
        return pulumi.get(self, "on_net_addrs")

    @on_net_addrs.setter
    def on_net_addrs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileOnNetAddrArgs']]]]):
        pulumi.set(self, "on_net_addrs", value)

    @property
    @pulumi.getter(name="profileName")
    def profile_name(self) -> Optional[pulumi.Input[str]]:
        """
        Profile name.
        """
        return pulumi.get(self, "profile_name")

    @profile_name.setter
    def profile_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "profile_name", value)

    @property
    @pulumi.getter(name="replacemsgOverrideGroup")
    def replacemsg_override_group(self) -> Optional[pulumi.Input[str]]:
        """
        Select an endpoint control replacement message override group from available options.
        """
        return pulumi.get(self, "replacemsg_override_group")

    @replacemsg_override_group.setter
    def replacemsg_override_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "replacemsg_override_group", value)

    @property
    @pulumi.getter(name="srcAddrs")
    def src_addrs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileSrcAddrArgs']]]]:
        """
        Source addresses. The structure of `src_addr` block is documented below.
        """
        return pulumi.get(self, "src_addrs")

    @src_addrs.setter
    def src_addrs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileSrcAddrArgs']]]]):
        pulumi.set(self, "src_addrs", value)

    @property
    @pulumi.getter(name="userGroups")
    def user_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserGroupArgs']]]]:
        """
        User groups. The structure of `user_groups` block is documented below.
        """
        return pulumi.get(self, "user_groups")

    @user_groups.setter
    def user_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserGroupArgs']]]]):
        pulumi.set(self, "user_groups", value)

    @property
    @pulumi.getter
    def users(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserArgs']]]]:
        """
        Users. The structure of `users` block is documented below.
        """
        return pulumi.get(self, "users")

    @users.setter
    def users(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserArgs']]]]):
        pulumi.set(self, "users", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


@pulumi.input_type
class _EndpointControlProfileState:
    def __init__(__self__, *,
                 description: Optional[pulumi.Input[str]] = None,
                 device_groups: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileDeviceGroupArgs']]]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 forticlient_android_settings: Optional[pulumi.Input['EndpointControlProfileForticlientAndroidSettingsArgs']] = None,
                 forticlient_ios_settings: Optional[pulumi.Input['EndpointControlProfileForticlientIosSettingsArgs']] = None,
                 forticlient_winmac_settings: Optional[pulumi.Input['EndpointControlProfileForticlientWinmacSettingsArgs']] = None,
                 on_net_addrs: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileOnNetAddrArgs']]]] = None,
                 profile_name: Optional[pulumi.Input[str]] = None,
                 replacemsg_override_group: Optional[pulumi.Input[str]] = None,
                 src_addrs: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileSrcAddrArgs']]]] = None,
                 user_groups: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserGroupArgs']]]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserArgs']]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering EndpointControlProfile resources.
        :param pulumi.Input[str] description: Description.
        :param pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileDeviceGroupArgs']]] device_groups: Device groups. The structure of `device_groups` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input['EndpointControlProfileForticlientAndroidSettingsArgs'] forticlient_android_settings: FortiClient settings for Android platform. The structure of `forticlient_android_settings` block is documented below.
        :param pulumi.Input['EndpointControlProfileForticlientIosSettingsArgs'] forticlient_ios_settings: FortiClient settings for iOS platform. The structure of `forticlient_ios_settings` block is documented below.
        :param pulumi.Input['EndpointControlProfileForticlientWinmacSettingsArgs'] forticlient_winmac_settings: FortiClient settings for Windows/Mac platform. The structure of `forticlient_winmac_settings` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileOnNetAddrArgs']]] on_net_addrs: Addresses for on-net detection. The structure of `on_net_addr` block is documented below.
        :param pulumi.Input[str] profile_name: Profile name.
        :param pulumi.Input[str] replacemsg_override_group: Select an endpoint control replacement message override group from available options.
        :param pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileSrcAddrArgs']]] src_addrs: Source addresses. The structure of `src_addr` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserGroupArgs']]] user_groups: User groups. The structure of `user_groups` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserArgs']]] users: Users. The structure of `users` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if device_groups is not None:
            pulumi.set(__self__, "device_groups", device_groups)
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if forticlient_android_settings is not None:
            pulumi.set(__self__, "forticlient_android_settings", forticlient_android_settings)
        if forticlient_ios_settings is not None:
            pulumi.set(__self__, "forticlient_ios_settings", forticlient_ios_settings)
        if forticlient_winmac_settings is not None:
            pulumi.set(__self__, "forticlient_winmac_settings", forticlient_winmac_settings)
        if on_net_addrs is not None:
            pulumi.set(__self__, "on_net_addrs", on_net_addrs)
        if profile_name is not None:
            pulumi.set(__self__, "profile_name", profile_name)
        if replacemsg_override_group is not None:
            pulumi.set(__self__, "replacemsg_override_group", replacemsg_override_group)
        if src_addrs is not None:
            pulumi.set(__self__, "src_addrs", src_addrs)
        if user_groups is not None:
            pulumi.set(__self__, "user_groups", user_groups)
        if users is not None:
            pulumi.set(__self__, "users", users)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="deviceGroups")
    def device_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileDeviceGroupArgs']]]]:
        """
        Device groups. The structure of `device_groups` block is documented below.
        """
        return pulumi.get(self, "device_groups")

    @device_groups.setter
    def device_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileDeviceGroupArgs']]]]):
        pulumi.set(self, "device_groups", value)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter(name="forticlientAndroidSettings")
    def forticlient_android_settings(self) -> Optional[pulumi.Input['EndpointControlProfileForticlientAndroidSettingsArgs']]:
        """
        FortiClient settings for Android platform. The structure of `forticlient_android_settings` block is documented below.
        """
        return pulumi.get(self, "forticlient_android_settings")

    @forticlient_android_settings.setter
    def forticlient_android_settings(self, value: Optional[pulumi.Input['EndpointControlProfileForticlientAndroidSettingsArgs']]):
        pulumi.set(self, "forticlient_android_settings", value)

    @property
    @pulumi.getter(name="forticlientIosSettings")
    def forticlient_ios_settings(self) -> Optional[pulumi.Input['EndpointControlProfileForticlientIosSettingsArgs']]:
        """
        FortiClient settings for iOS platform. The structure of `forticlient_ios_settings` block is documented below.
        """
        return pulumi.get(self, "forticlient_ios_settings")

    @forticlient_ios_settings.setter
    def forticlient_ios_settings(self, value: Optional[pulumi.Input['EndpointControlProfileForticlientIosSettingsArgs']]):
        pulumi.set(self, "forticlient_ios_settings", value)

    @property
    @pulumi.getter(name="forticlientWinmacSettings")
    def forticlient_winmac_settings(self) -> Optional[pulumi.Input['EndpointControlProfileForticlientWinmacSettingsArgs']]:
        """
        FortiClient settings for Windows/Mac platform. The structure of `forticlient_winmac_settings` block is documented below.
        """
        return pulumi.get(self, "forticlient_winmac_settings")

    @forticlient_winmac_settings.setter
    def forticlient_winmac_settings(self, value: Optional[pulumi.Input['EndpointControlProfileForticlientWinmacSettingsArgs']]):
        pulumi.set(self, "forticlient_winmac_settings", value)

    @property
    @pulumi.getter(name="onNetAddrs")
    def on_net_addrs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileOnNetAddrArgs']]]]:
        """
        Addresses for on-net detection. The structure of `on_net_addr` block is documented below.
        """
        return pulumi.get(self, "on_net_addrs")

    @on_net_addrs.setter
    def on_net_addrs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileOnNetAddrArgs']]]]):
        pulumi.set(self, "on_net_addrs", value)

    @property
    @pulumi.getter(name="profileName")
    def profile_name(self) -> Optional[pulumi.Input[str]]:
        """
        Profile name.
        """
        return pulumi.get(self, "profile_name")

    @profile_name.setter
    def profile_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "profile_name", value)

    @property
    @pulumi.getter(name="replacemsgOverrideGroup")
    def replacemsg_override_group(self) -> Optional[pulumi.Input[str]]:
        """
        Select an endpoint control replacement message override group from available options.
        """
        return pulumi.get(self, "replacemsg_override_group")

    @replacemsg_override_group.setter
    def replacemsg_override_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "replacemsg_override_group", value)

    @property
    @pulumi.getter(name="srcAddrs")
    def src_addrs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileSrcAddrArgs']]]]:
        """
        Source addresses. The structure of `src_addr` block is documented below.
        """
        return pulumi.get(self, "src_addrs")

    @src_addrs.setter
    def src_addrs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileSrcAddrArgs']]]]):
        pulumi.set(self, "src_addrs", value)

    @property
    @pulumi.getter(name="userGroups")
    def user_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserGroupArgs']]]]:
        """
        User groups. The structure of `user_groups` block is documented below.
        """
        return pulumi.get(self, "user_groups")

    @user_groups.setter
    def user_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserGroupArgs']]]]):
        pulumi.set(self, "user_groups", value)

    @property
    @pulumi.getter
    def users(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserArgs']]]]:
        """
        Users. The structure of `users` block is documented below.
        """
        return pulumi.get(self, "users")

    @users.setter
    def users(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['EndpointControlProfileUserArgs']]]]):
        pulumi.set(self, "users", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


class EndpointControlProfile(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device_groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileDeviceGroupArgs']]]]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 forticlient_android_settings: Optional[pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientAndroidSettingsArgs']]] = None,
                 forticlient_ios_settings: Optional[pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientIosSettingsArgs']]] = None,
                 forticlient_winmac_settings: Optional[pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientWinmacSettingsArgs']]] = None,
                 on_net_addrs: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileOnNetAddrArgs']]]]] = None,
                 profile_name: Optional[pulumi.Input[str]] = None,
                 replacemsg_override_group: Optional[pulumi.Input[str]] = None,
                 src_addrs: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileSrcAddrArgs']]]]] = None,
                 user_groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileUserGroupArgs']]]]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileUserArgs']]]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Configure FortiClient endpoint control profiles. Applies to FortiOS Version `<= 6.2.0`.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_fortios as fortios

        trname = fortios.EndpointControlProfile("trname",
            device_groups=[fortios.EndpointControlProfileDeviceGroupArgs(
                name="Mobile Devices",
            )],
            forticlient_android_settings=fortios.EndpointControlProfileForticlientAndroidSettingsArgs(
                disable_wf_when_protected="enable",
                forticlient_advanced_vpn="disable",
                forticlient_vpn_provisioning="disable",
                forticlient_wf="disable",
            ),
            forticlient_ios_settings=fortios.EndpointControlProfileForticlientIosSettingsArgs(
                client_vpn_provisioning="disable",
                disable_wf_when_protected="enable",
                distribute_configuration_profile="disable",
                forticlient_wf="disable",
            ),
            forticlient_winmac_settings=fortios.EndpointControlProfileForticlientWinmacSettingsArgs(
                av_realtime_protection="disable",
                av_signature_up_to_date="disable",
                forticlient_application_firewall="disable",
                forticlient_av="disable",
                forticlient_ems_compliance="disable",
                forticlient_ems_compliance_action="warning",
                forticlient_linux_ver="5.4.1",
                forticlient_log_upload="enable",
                forticlient_log_upload_level="traffic vulnerability event",
                forticlient_mac_ver="5.4.1",
                forticlient_minimum_software_version="disable",
                forticlient_registration_compliance_action="warning",
                forticlient_security_posture="disable",
                forticlient_security_posture_compliance_action="warning",
                forticlient_system_compliance="enable",
                forticlient_system_compliance_action="warning",
                forticlient_vuln_scan="enable",
                forticlient_vuln_scan_compliance_action="warning",
                forticlient_vuln_scan_enforce="high",
                forticlient_vuln_scan_enforce_grace=1,
                forticlient_vuln_scan_exempt="disable",
                forticlient_wf="disable",
                forticlient_win_ver="5.4.1",
                os_av_software_installed="disable",
                sandbox_analysis="disable",
            ),
            on_net_addrs=[fortios.EndpointControlProfileOnNetAddrArgs(
                name="all",
            )],
            profile_name="1",
            users=[fortios.EndpointControlProfileUserArgs(
                name="guest",
            )])
        ```

        ## Import

        EndpointControl Profile can be imported using any of these accepted formats$ export "FORTIOS_IMPORT_TABLE"="true"

        ```sh
         $ pulumi import fortios:index/endpointControlProfile:EndpointControlProfile labelname {{profile_name}}
        ```

         $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Description.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileDeviceGroupArgs']]]] device_groups: Device groups. The structure of `device_groups` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientAndroidSettingsArgs']] forticlient_android_settings: FortiClient settings for Android platform. The structure of `forticlient_android_settings` block is documented below.
        :param pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientIosSettingsArgs']] forticlient_ios_settings: FortiClient settings for iOS platform. The structure of `forticlient_ios_settings` block is documented below.
        :param pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientWinmacSettingsArgs']] forticlient_winmac_settings: FortiClient settings for Windows/Mac platform. The structure of `forticlient_winmac_settings` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileOnNetAddrArgs']]]] on_net_addrs: Addresses for on-net detection. The structure of `on_net_addr` block is documented below.
        :param pulumi.Input[str] profile_name: Profile name.
        :param pulumi.Input[str] replacemsg_override_group: Select an endpoint control replacement message override group from available options.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileSrcAddrArgs']]]] src_addrs: Source addresses. The structure of `src_addr` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileUserGroupArgs']]]] user_groups: User groups. The structure of `user_groups` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileUserArgs']]]] users: Users. The structure of `users` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[EndpointControlProfileArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Configure FortiClient endpoint control profiles. Applies to FortiOS Version `<= 6.2.0`.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_fortios as fortios

        trname = fortios.EndpointControlProfile("trname",
            device_groups=[fortios.EndpointControlProfileDeviceGroupArgs(
                name="Mobile Devices",
            )],
            forticlient_android_settings=fortios.EndpointControlProfileForticlientAndroidSettingsArgs(
                disable_wf_when_protected="enable",
                forticlient_advanced_vpn="disable",
                forticlient_vpn_provisioning="disable",
                forticlient_wf="disable",
            ),
            forticlient_ios_settings=fortios.EndpointControlProfileForticlientIosSettingsArgs(
                client_vpn_provisioning="disable",
                disable_wf_when_protected="enable",
                distribute_configuration_profile="disable",
                forticlient_wf="disable",
            ),
            forticlient_winmac_settings=fortios.EndpointControlProfileForticlientWinmacSettingsArgs(
                av_realtime_protection="disable",
                av_signature_up_to_date="disable",
                forticlient_application_firewall="disable",
                forticlient_av="disable",
                forticlient_ems_compliance="disable",
                forticlient_ems_compliance_action="warning",
                forticlient_linux_ver="5.4.1",
                forticlient_log_upload="enable",
                forticlient_log_upload_level="traffic vulnerability event",
                forticlient_mac_ver="5.4.1",
                forticlient_minimum_software_version="disable",
                forticlient_registration_compliance_action="warning",
                forticlient_security_posture="disable",
                forticlient_security_posture_compliance_action="warning",
                forticlient_system_compliance="enable",
                forticlient_system_compliance_action="warning",
                forticlient_vuln_scan="enable",
                forticlient_vuln_scan_compliance_action="warning",
                forticlient_vuln_scan_enforce="high",
                forticlient_vuln_scan_enforce_grace=1,
                forticlient_vuln_scan_exempt="disable",
                forticlient_wf="disable",
                forticlient_win_ver="5.4.1",
                os_av_software_installed="disable",
                sandbox_analysis="disable",
            ),
            on_net_addrs=[fortios.EndpointControlProfileOnNetAddrArgs(
                name="all",
            )],
            profile_name="1",
            users=[fortios.EndpointControlProfileUserArgs(
                name="guest",
            )])
        ```

        ## Import

        EndpointControl Profile can be imported using any of these accepted formats$ export "FORTIOS_IMPORT_TABLE"="true"

        ```sh
         $ pulumi import fortios:index/endpointControlProfile:EndpointControlProfile labelname {{profile_name}}
        ```

         $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param EndpointControlProfileArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(EndpointControlProfileArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device_groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileDeviceGroupArgs']]]]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 forticlient_android_settings: Optional[pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientAndroidSettingsArgs']]] = None,
                 forticlient_ios_settings: Optional[pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientIosSettingsArgs']]] = None,
                 forticlient_winmac_settings: Optional[pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientWinmacSettingsArgs']]] = None,
                 on_net_addrs: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileOnNetAddrArgs']]]]] = None,
                 profile_name: Optional[pulumi.Input[str]] = None,
                 replacemsg_override_group: Optional[pulumi.Input[str]] = None,
                 src_addrs: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileSrcAddrArgs']]]]] = None,
                 user_groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileUserGroupArgs']]]]] = None,
                 users: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileUserArgs']]]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = EndpointControlProfileArgs.__new__(EndpointControlProfileArgs)

            __props__.__dict__["description"] = description
            __props__.__dict__["device_groups"] = device_groups
            __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
            __props__.__dict__["forticlient_android_settings"] = forticlient_android_settings
            __props__.__dict__["forticlient_ios_settings"] = forticlient_ios_settings
            __props__.__dict__["forticlient_winmac_settings"] = forticlient_winmac_settings
            __props__.__dict__["on_net_addrs"] = on_net_addrs
            __props__.__dict__["profile_name"] = profile_name
            __props__.__dict__["replacemsg_override_group"] = replacemsg_override_group
            __props__.__dict__["src_addrs"] = src_addrs
            __props__.__dict__["user_groups"] = user_groups
            __props__.__dict__["users"] = users
            __props__.__dict__["vdomparam"] = vdomparam
        super(EndpointControlProfile, __self__).__init__(
            'fortios:index/endpointControlProfile:EndpointControlProfile',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            description: Optional[pulumi.Input[str]] = None,
            device_groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileDeviceGroupArgs']]]]] = None,
            dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
            forticlient_android_settings: Optional[pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientAndroidSettingsArgs']]] = None,
            forticlient_ios_settings: Optional[pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientIosSettingsArgs']]] = None,
            forticlient_winmac_settings: Optional[pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientWinmacSettingsArgs']]] = None,
            on_net_addrs: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileOnNetAddrArgs']]]]] = None,
            profile_name: Optional[pulumi.Input[str]] = None,
            replacemsg_override_group: Optional[pulumi.Input[str]] = None,
            src_addrs: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileSrcAddrArgs']]]]] = None,
            user_groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileUserGroupArgs']]]]] = None,
            users: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileUserArgs']]]]] = None,
            vdomparam: Optional[pulumi.Input[str]] = None) -> 'EndpointControlProfile':
        """
        Get an existing EndpointControlProfile resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Description.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileDeviceGroupArgs']]]] device_groups: Device groups. The structure of `device_groups` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientAndroidSettingsArgs']] forticlient_android_settings: FortiClient settings for Android platform. The structure of `forticlient_android_settings` block is documented below.
        :param pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientIosSettingsArgs']] forticlient_ios_settings: FortiClient settings for iOS platform. The structure of `forticlient_ios_settings` block is documented below.
        :param pulumi.Input[pulumi.InputType['EndpointControlProfileForticlientWinmacSettingsArgs']] forticlient_winmac_settings: FortiClient settings for Windows/Mac platform. The structure of `forticlient_winmac_settings` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileOnNetAddrArgs']]]] on_net_addrs: Addresses for on-net detection. The structure of `on_net_addr` block is documented below.
        :param pulumi.Input[str] profile_name: Profile name.
        :param pulumi.Input[str] replacemsg_override_group: Select an endpoint control replacement message override group from available options.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileSrcAddrArgs']]]] src_addrs: Source addresses. The structure of `src_addr` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileUserGroupArgs']]]] user_groups: User groups. The structure of `user_groups` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['EndpointControlProfileUserArgs']]]] users: Users. The structure of `users` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _EndpointControlProfileState.__new__(_EndpointControlProfileState)

        __props__.__dict__["description"] = description
        __props__.__dict__["device_groups"] = device_groups
        __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
        __props__.__dict__["forticlient_android_settings"] = forticlient_android_settings
        __props__.__dict__["forticlient_ios_settings"] = forticlient_ios_settings
        __props__.__dict__["forticlient_winmac_settings"] = forticlient_winmac_settings
        __props__.__dict__["on_net_addrs"] = on_net_addrs
        __props__.__dict__["profile_name"] = profile_name
        __props__.__dict__["replacemsg_override_group"] = replacemsg_override_group
        __props__.__dict__["src_addrs"] = src_addrs
        __props__.__dict__["user_groups"] = user_groups
        __props__.__dict__["users"] = users
        __props__.__dict__["vdomparam"] = vdomparam
        return EndpointControlProfile(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="deviceGroups")
    def device_groups(self) -> pulumi.Output[Optional[Sequence['outputs.EndpointControlProfileDeviceGroup']]]:
        """
        Device groups. The structure of `device_groups` block is documented below.
        """
        return pulumi.get(self, "device_groups")

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> pulumi.Output[Optional[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @property
    @pulumi.getter(name="forticlientAndroidSettings")
    def forticlient_android_settings(self) -> pulumi.Output[Optional['outputs.EndpointControlProfileForticlientAndroidSettings']]:
        """
        FortiClient settings for Android platform. The structure of `forticlient_android_settings` block is documented below.
        """
        return pulumi.get(self, "forticlient_android_settings")

    @property
    @pulumi.getter(name="forticlientIosSettings")
    def forticlient_ios_settings(self) -> pulumi.Output[Optional['outputs.EndpointControlProfileForticlientIosSettings']]:
        """
        FortiClient settings for iOS platform. The structure of `forticlient_ios_settings` block is documented below.
        """
        return pulumi.get(self, "forticlient_ios_settings")

    @property
    @pulumi.getter(name="forticlientWinmacSettings")
    def forticlient_winmac_settings(self) -> pulumi.Output[Optional['outputs.EndpointControlProfileForticlientWinmacSettings']]:
        """
        FortiClient settings for Windows/Mac platform. The structure of `forticlient_winmac_settings` block is documented below.
        """
        return pulumi.get(self, "forticlient_winmac_settings")

    @property
    @pulumi.getter(name="onNetAddrs")
    def on_net_addrs(self) -> pulumi.Output[Optional[Sequence['outputs.EndpointControlProfileOnNetAddr']]]:
        """
        Addresses for on-net detection. The structure of `on_net_addr` block is documented below.
        """
        return pulumi.get(self, "on_net_addrs")

    @property
    @pulumi.getter(name="profileName")
    def profile_name(self) -> pulumi.Output[str]:
        """
        Profile name.
        """
        return pulumi.get(self, "profile_name")

    @property
    @pulumi.getter(name="replacemsgOverrideGroup")
    def replacemsg_override_group(self) -> pulumi.Output[str]:
        """
        Select an endpoint control replacement message override group from available options.
        """
        return pulumi.get(self, "replacemsg_override_group")

    @property
    @pulumi.getter(name="srcAddrs")
    def src_addrs(self) -> pulumi.Output[Optional[Sequence['outputs.EndpointControlProfileSrcAddr']]]:
        """
        Source addresses. The structure of `src_addr` block is documented below.
        """
        return pulumi.get(self, "src_addrs")

    @property
    @pulumi.getter(name="userGroups")
    def user_groups(self) -> pulumi.Output[Optional[Sequence['outputs.EndpointControlProfileUserGroup']]]:
        """
        User groups. The structure of `user_groups` block is documented below.
        """
        return pulumi.get(self, "user_groups")

    @property
    @pulumi.getter
    def users(self) -> pulumi.Output[Optional[Sequence['outputs.EndpointControlProfileUser']]]:
        """
        Users. The structure of `users` block is documented below.
        """
        return pulumi.get(self, "users")

    @property
    @pulumi.getter
    def vdomparam(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

