# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetFirewallScheduleOnetimeResult',
    'AwaitableGetFirewallScheduleOnetimeResult',
    'get_firewall_schedule_onetime',
]

@pulumi.output_type
class GetFirewallScheduleOnetimeResult:
    """
    A collection of values returned by GetFirewallScheduleOnetime.
    """
    def __init__(__self__, color=None, end=None, expiration_days=None, id=None, name=None, start=None, vdomparam=None):
        if color and not isinstance(color, int):
            raise TypeError("Expected argument 'color' to be a int")
        pulumi.set(__self__, "color", color)
        if end and not isinstance(end, str):
            raise TypeError("Expected argument 'end' to be a str")
        pulumi.set(__self__, "end", end)
        if expiration_days and not isinstance(expiration_days, int):
            raise TypeError("Expected argument 'expiration_days' to be a int")
        pulumi.set(__self__, "expiration_days", expiration_days)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if start and not isinstance(start, str):
            raise TypeError("Expected argument 'start' to be a str")
        pulumi.set(__self__, "start", start)
        if vdomparam and not isinstance(vdomparam, str):
            raise TypeError("Expected argument 'vdomparam' to be a str")
        pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def color(self) -> int:
        """
        Color of icon on the GUI.
        """
        return pulumi.get(self, "color")

    @property
    @pulumi.getter
    def end(self) -> str:
        """
        Schedule end date and time, format hh:mm yyyy/mm/dd.
        """
        return pulumi.get(self, "end")

    @property
    @pulumi.getter(name="expirationDays")
    def expiration_days(self) -> int:
        """
        Write an event log message this many days before the schedule expires.
        """
        return pulumi.get(self, "expiration_days")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Onetime schedule name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def start(self) -> str:
        """
        Schedule start date and time, format hh:mm yyyy/mm/dd.
        """
        return pulumi.get(self, "start")

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[str]:
        return pulumi.get(self, "vdomparam")


class AwaitableGetFirewallScheduleOnetimeResult(GetFirewallScheduleOnetimeResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFirewallScheduleOnetimeResult(
            color=self.color,
            end=self.end,
            expiration_days=self.expiration_days,
            id=self.id,
            name=self.name,
            start=self.start,
            vdomparam=self.vdomparam)


def get_firewall_schedule_onetime(name: Optional[str] = None,
                                  vdomparam: Optional[str] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFirewallScheduleOnetimeResult:
    """
    Use this data source to get information on an fortios firewallschedule onetime


    :param str name: Specify the name of the desired firewallschedule onetime.
    :param str vdomparam: Specifies the vdom to which the data source will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['vdomparam'] = vdomparam
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('fortios:index/getFirewallScheduleOnetime:GetFirewallScheduleOnetime', __args__, opts=opts, typ=GetFirewallScheduleOnetimeResult).value

    return AwaitableGetFirewallScheduleOnetimeResult(
        color=__ret__.color,
        end=__ret__.end,
        expiration_days=__ret__.expiration_days,
        id=__ret__.id,
        name=__ret__.name,
        start=__ret__.start,
        vdomparam=__ret__.vdomparam)
