# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetJSONGenericAPIResult',
    'AwaitableGetJSONGenericAPIResult',
    'get_json_generic_api',
]

@pulumi.output_type
class GetJSONGenericAPIResult:
    """
    A collection of values returned by GetJSONGenericAPI.
    """
    def __init__(__self__, id=None, path=None, response=None, specialparams=None, vdomparam=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if path and not isinstance(path, str):
            raise TypeError("Expected argument 'path' to be a str")
        pulumi.set(__self__, "path", path)
        if response and not isinstance(response, str):
            raise TypeError("Expected argument 'response' to be a str")
        pulumi.set(__self__, "response", response)
        if specialparams and not isinstance(specialparams, str):
            raise TypeError("Expected argument 'specialparams' to be a str")
        pulumi.set(__self__, "specialparams", specialparams)
        if vdomparam and not isinstance(vdomparam, str):
            raise TypeError("Expected argument 'vdomparam' to be a str")
        pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def path(self) -> str:
        """
        FortiAPI URL path.
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter
    def response(self) -> str:
        """
        FortiAPI returns results.
        """
        return pulumi.get(self, "response")

    @property
    @pulumi.getter
    def specialparams(self) -> Optional[str]:
        """
        URL parameters, in addition to the URL path, user can specify URL parameters which are appended to the URL path..
        """
        return pulumi.get(self, "specialparams")

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[str]:
        return pulumi.get(self, "vdomparam")


class AwaitableGetJSONGenericAPIResult(GetJSONGenericAPIResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetJSONGenericAPIResult(
            id=self.id,
            path=self.path,
            response=self.response,
            specialparams=self.specialparams,
            vdomparam=self.vdomparam)


def get_json_generic_api(path: Optional[str] = None,
                         specialparams: Optional[str] = None,
                         vdomparam: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetJSONGenericAPIResult:
    """
    Provides a FortiAPI Generic Interface data source.


    :param str path: FortiAPI URL path.
    :param str specialparams: URL parameters, in addition to the URL path, user can specify URL parameters which are appended to the URL path..
    """
    __args__ = dict()
    __args__['path'] = path
    __args__['specialparams'] = specialparams
    __args__['vdomparam'] = vdomparam
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('fortios:index/getJSONGenericAPI:GetJSONGenericAPI', __args__, opts=opts, typ=GetJSONGenericAPIResult).value

    return AwaitableGetJSONGenericAPIResult(
        id=__ret__.id,
        path=__ret__.path,
        response=__ret__.response,
        specialparams=__ret__.specialparams,
        vdomparam=__ret__.vdomparam)
