# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetSystemConsoleResult',
    'AwaitableGetSystemConsoleResult',
    'get_system_console',
]

@pulumi.output_type
class GetSystemConsoleResult:
    """
    A collection of values returned by GetSystemConsole.
    """
    def __init__(__self__, baudrate=None, id=None, login=None, mode=None, output=None, vdomparam=None):
        if baudrate and not isinstance(baudrate, str):
            raise TypeError("Expected argument 'baudrate' to be a str")
        pulumi.set(__self__, "baudrate", baudrate)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if login and not isinstance(login, str):
            raise TypeError("Expected argument 'login' to be a str")
        pulumi.set(__self__, "login", login)
        if mode and not isinstance(mode, str):
            raise TypeError("Expected argument 'mode' to be a str")
        pulumi.set(__self__, "mode", mode)
        if output and not isinstance(output, str):
            raise TypeError("Expected argument 'output' to be a str")
        pulumi.set(__self__, "output", output)
        if vdomparam and not isinstance(vdomparam, str):
            raise TypeError("Expected argument 'vdomparam' to be a str")
        pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def baudrate(self) -> str:
        """
        Console baud rate.
        """
        return pulumi.get(self, "baudrate")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def login(self) -> str:
        """
        Enable/disable serial console and FortiExplorer.
        """
        return pulumi.get(self, "login")

    @property
    @pulumi.getter
    def mode(self) -> str:
        """
        Console mode.
        """
        return pulumi.get(self, "mode")

    @property
    @pulumi.getter
    def output(self) -> str:
        """
        Console output mode.
        """
        return pulumi.get(self, "output")

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[str]:
        return pulumi.get(self, "vdomparam")


class AwaitableGetSystemConsoleResult(GetSystemConsoleResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSystemConsoleResult(
            baudrate=self.baudrate,
            id=self.id,
            login=self.login,
            mode=self.mode,
            output=self.output,
            vdomparam=self.vdomparam)


def get_system_console(vdomparam: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSystemConsoleResult:
    """
    Use this data source to get information on fortios system console


    :param str vdomparam: Specifies the vdom to which the data source will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
    """
    __args__ = dict()
    __args__['vdomparam'] = vdomparam
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('fortios:index/getSystemConsole:GetSystemConsole', __args__, opts=opts, typ=GetSystemConsoleResult).value

    return AwaitableGetSystemConsoleResult(
        baudrate=__ret__.baudrate,
        id=__ret__.id,
        login=__ret__.login,
        mode=__ret__.mode,
        output=__ret__.output,
        vdomparam=__ret__.vdomparam)
