# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetSystemFtmPushResult',
    'AwaitableGetSystemFtmPushResult',
    'get_system_ftm_push',
]

@pulumi.output_type
class GetSystemFtmPushResult:
    """
    A collection of values returned by GetSystemFtmPush.
    """
    def __init__(__self__, id=None, server_cert=None, server_ip=None, server_port=None, status=None, vdomparam=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if server_cert and not isinstance(server_cert, str):
            raise TypeError("Expected argument 'server_cert' to be a str")
        pulumi.set(__self__, "server_cert", server_cert)
        if server_ip and not isinstance(server_ip, str):
            raise TypeError("Expected argument 'server_ip' to be a str")
        pulumi.set(__self__, "server_ip", server_ip)
        if server_port and not isinstance(server_port, int):
            raise TypeError("Expected argument 'server_port' to be a int")
        pulumi.set(__self__, "server_port", server_port)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)
        if vdomparam and not isinstance(vdomparam, str):
            raise TypeError("Expected argument 'vdomparam' to be a str")
        pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="serverCert")
    def server_cert(self) -> str:
        """
        Name of the server certificate to be used for SSL (default = Fortinet_Factory).
        """
        return pulumi.get(self, "server_cert")

    @property
    @pulumi.getter(name="serverIp")
    def server_ip(self) -> str:
        """
        IPv4 address of FortiToken Mobile push services server (format: xxx.xxx.xxx.xxx).
        """
        return pulumi.get(self, "server_ip")

    @property
    @pulumi.getter(name="serverPort")
    def server_port(self) -> int:
        """
        Port to communicate with FortiToken Mobile push services server (1 - 65535, default = 4433).
        """
        return pulumi.get(self, "server_port")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        Enable/disable the use of FortiToken Mobile push services.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[str]:
        return pulumi.get(self, "vdomparam")


class AwaitableGetSystemFtmPushResult(GetSystemFtmPushResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSystemFtmPushResult(
            id=self.id,
            server_cert=self.server_cert,
            server_ip=self.server_ip,
            server_port=self.server_port,
            status=self.status,
            vdomparam=self.vdomparam)


def get_system_ftm_push(vdomparam: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSystemFtmPushResult:
    """
    Use this data source to get information on fortios system ftmpush


    :param str vdomparam: Specifies the vdom to which the data source will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
    """
    __args__ = dict()
    __args__['vdomparam'] = vdomparam
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('fortios:index/getSystemFtmPush:GetSystemFtmPush', __args__, opts=opts, typ=GetSystemFtmPushResult).value

    return AwaitableGetSystemFtmPushResult(
        id=__ret__.id,
        server_cert=__ret__.server_cert,
        server_ip=__ret__.server_ip,
        server_port=__ret__.server_port,
        status=__ret__.status,
        vdomparam=__ret__.vdomparam)
