# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['SystemSdwanArgs', 'SystemSdwan']

@pulumi.input_type
class SystemSdwanArgs:
    def __init__(__self__, *,
                 duplication_max_num: Optional[pulumi.Input[int]] = None,
                 duplications: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanDuplicationArgs']]]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 fail_alert_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanFailAlertInterfaceArgs']]]] = None,
                 fail_detect: Optional[pulumi.Input[str]] = None,
                 health_checks: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanHealthCheckArgs']]]] = None,
                 load_balance_mode: Optional[pulumi.Input[str]] = None,
                 members: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanMemberArgs']]]] = None,
                 neighbor_hold_boot_time: Optional[pulumi.Input[int]] = None,
                 neighbor_hold_down: Optional[pulumi.Input[str]] = None,
                 neighbor_hold_down_time: Optional[pulumi.Input[int]] = None,
                 neighbors: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanNeighborArgs']]]] = None,
                 services: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanServiceArgs']]]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 zones: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanZoneArgs']]]] = None):
        """
        The set of arguments for constructing a SystemSdwan resource.
        :param pulumi.Input[int] duplication_max_num: Maximum number of interface members a packet is duplicated in the SD-WAN zone (2 - 4, default = 2; if set to 3, the original packet plus 2 more copies are created).
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanDuplicationArgs']]] duplications: Create SD-WAN duplication rule. The structure of `duplication` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanFailAlertInterfaceArgs']]] fail_alert_interfaces: Physical interfaces that will be alerted. The structure of `fail_alert_interfaces` block is documented below.
        :param pulumi.Input[str] fail_detect: Enable/disable SD-WAN Internet connection status checking (failure detection). Valid values: `enable`, `disable`.
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanHealthCheckArgs']]] health_checks: SD-WAN health-check.
        :param pulumi.Input[str] load_balance_mode: Algorithm or mode to use for load balancing Internet traffic to SD-WAN members. Valid values: `source-ip-based`, `weight-based`, `usage-based`, `source-dest-ip-based`, `measured-volume-based`.
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanMemberArgs']]] members: Member sequence number list. The structure of `members` block is documented below.
        :param pulumi.Input[int] neighbor_hold_boot_time: Waiting period in seconds when switching from the primary neighbor to the secondary neighbor from the neighbor start. (0 - 10000000, default = 0).
        :param pulumi.Input[str] neighbor_hold_down: Enable/disable hold switching from the secondary neighbor to the primary neighbor. Valid values: `enable`, `disable`.
        :param pulumi.Input[int] neighbor_hold_down_time: Waiting period in seconds when switching from the secondary neighbor to the primary neighbor when hold-down is disabled. (0 - 10000000, default = 0).
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanNeighborArgs']]] neighbors: Create SD-WAN neighbor from BGP neighbor table to control route advertisements according to SLA status. The structure of `neighbor` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanServiceArgs']]] services: Service and service group name. The structure of `service` block is documented below.
        :param pulumi.Input[str] status: Enable/disable SD-WAN service. Valid values: `enable`, `disable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanZoneArgs']]] zones: Zone name.
        """
        if duplication_max_num is not None:
            pulumi.set(__self__, "duplication_max_num", duplication_max_num)
        if duplications is not None:
            pulumi.set(__self__, "duplications", duplications)
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if fail_alert_interfaces is not None:
            pulumi.set(__self__, "fail_alert_interfaces", fail_alert_interfaces)
        if fail_detect is not None:
            pulumi.set(__self__, "fail_detect", fail_detect)
        if health_checks is not None:
            pulumi.set(__self__, "health_checks", health_checks)
        if load_balance_mode is not None:
            pulumi.set(__self__, "load_balance_mode", load_balance_mode)
        if members is not None:
            pulumi.set(__self__, "members", members)
        if neighbor_hold_boot_time is not None:
            pulumi.set(__self__, "neighbor_hold_boot_time", neighbor_hold_boot_time)
        if neighbor_hold_down is not None:
            pulumi.set(__self__, "neighbor_hold_down", neighbor_hold_down)
        if neighbor_hold_down_time is not None:
            pulumi.set(__self__, "neighbor_hold_down_time", neighbor_hold_down_time)
        if neighbors is not None:
            pulumi.set(__self__, "neighbors", neighbors)
        if services is not None:
            pulumi.set(__self__, "services", services)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)
        if zones is not None:
            pulumi.set(__self__, "zones", zones)

    @property
    @pulumi.getter(name="duplicationMaxNum")
    def duplication_max_num(self) -> Optional[pulumi.Input[int]]:
        """
        Maximum number of interface members a packet is duplicated in the SD-WAN zone (2 - 4, default = 2; if set to 3, the original packet plus 2 more copies are created).
        """
        return pulumi.get(self, "duplication_max_num")

    @duplication_max_num.setter
    def duplication_max_num(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "duplication_max_num", value)

    @property
    @pulumi.getter
    def duplications(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanDuplicationArgs']]]]:
        """
        Create SD-WAN duplication rule. The structure of `duplication` block is documented below.
        """
        return pulumi.get(self, "duplications")

    @duplications.setter
    def duplications(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanDuplicationArgs']]]]):
        pulumi.set(self, "duplications", value)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter(name="failAlertInterfaces")
    def fail_alert_interfaces(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanFailAlertInterfaceArgs']]]]:
        """
        Physical interfaces that will be alerted. The structure of `fail_alert_interfaces` block is documented below.
        """
        return pulumi.get(self, "fail_alert_interfaces")

    @fail_alert_interfaces.setter
    def fail_alert_interfaces(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanFailAlertInterfaceArgs']]]]):
        pulumi.set(self, "fail_alert_interfaces", value)

    @property
    @pulumi.getter(name="failDetect")
    def fail_detect(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable SD-WAN Internet connection status checking (failure detection). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "fail_detect")

    @fail_detect.setter
    def fail_detect(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "fail_detect", value)

    @property
    @pulumi.getter(name="healthChecks")
    def health_checks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanHealthCheckArgs']]]]:
        """
        SD-WAN health-check.
        """
        return pulumi.get(self, "health_checks")

    @health_checks.setter
    def health_checks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanHealthCheckArgs']]]]):
        pulumi.set(self, "health_checks", value)

    @property
    @pulumi.getter(name="loadBalanceMode")
    def load_balance_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Algorithm or mode to use for load balancing Internet traffic to SD-WAN members. Valid values: `source-ip-based`, `weight-based`, `usage-based`, `source-dest-ip-based`, `measured-volume-based`.
        """
        return pulumi.get(self, "load_balance_mode")

    @load_balance_mode.setter
    def load_balance_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "load_balance_mode", value)

    @property
    @pulumi.getter
    def members(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanMemberArgs']]]]:
        """
        Member sequence number list. The structure of `members` block is documented below.
        """
        return pulumi.get(self, "members")

    @members.setter
    def members(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanMemberArgs']]]]):
        pulumi.set(self, "members", value)

    @property
    @pulumi.getter(name="neighborHoldBootTime")
    def neighbor_hold_boot_time(self) -> Optional[pulumi.Input[int]]:
        """
        Waiting period in seconds when switching from the primary neighbor to the secondary neighbor from the neighbor start. (0 - 10000000, default = 0).
        """
        return pulumi.get(self, "neighbor_hold_boot_time")

    @neighbor_hold_boot_time.setter
    def neighbor_hold_boot_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "neighbor_hold_boot_time", value)

    @property
    @pulumi.getter(name="neighborHoldDown")
    def neighbor_hold_down(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable hold switching from the secondary neighbor to the primary neighbor. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "neighbor_hold_down")

    @neighbor_hold_down.setter
    def neighbor_hold_down(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "neighbor_hold_down", value)

    @property
    @pulumi.getter(name="neighborHoldDownTime")
    def neighbor_hold_down_time(self) -> Optional[pulumi.Input[int]]:
        """
        Waiting period in seconds when switching from the secondary neighbor to the primary neighbor when hold-down is disabled. (0 - 10000000, default = 0).
        """
        return pulumi.get(self, "neighbor_hold_down_time")

    @neighbor_hold_down_time.setter
    def neighbor_hold_down_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "neighbor_hold_down_time", value)

    @property
    @pulumi.getter
    def neighbors(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanNeighborArgs']]]]:
        """
        Create SD-WAN neighbor from BGP neighbor table to control route advertisements according to SLA status. The structure of `neighbor` block is documented below.
        """
        return pulumi.get(self, "neighbors")

    @neighbors.setter
    def neighbors(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanNeighborArgs']]]]):
        pulumi.set(self, "neighbors", value)

    @property
    @pulumi.getter
    def services(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanServiceArgs']]]]:
        """
        Service and service group name. The structure of `service` block is documented below.
        """
        return pulumi.get(self, "services")

    @services.setter
    def services(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanServiceArgs']]]]):
        pulumi.set(self, "services", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable SD-WAN service. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)

    @property
    @pulumi.getter
    def zones(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanZoneArgs']]]]:
        """
        Zone name.
        """
        return pulumi.get(self, "zones")

    @zones.setter
    def zones(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanZoneArgs']]]]):
        pulumi.set(self, "zones", value)


@pulumi.input_type
class _SystemSdwanState:
    def __init__(__self__, *,
                 duplication_max_num: Optional[pulumi.Input[int]] = None,
                 duplications: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanDuplicationArgs']]]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 fail_alert_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanFailAlertInterfaceArgs']]]] = None,
                 fail_detect: Optional[pulumi.Input[str]] = None,
                 health_checks: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanHealthCheckArgs']]]] = None,
                 load_balance_mode: Optional[pulumi.Input[str]] = None,
                 members: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanMemberArgs']]]] = None,
                 neighbor_hold_boot_time: Optional[pulumi.Input[int]] = None,
                 neighbor_hold_down: Optional[pulumi.Input[str]] = None,
                 neighbor_hold_down_time: Optional[pulumi.Input[int]] = None,
                 neighbors: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanNeighborArgs']]]] = None,
                 services: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanServiceArgs']]]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 zones: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanZoneArgs']]]] = None):
        """
        Input properties used for looking up and filtering SystemSdwan resources.
        :param pulumi.Input[int] duplication_max_num: Maximum number of interface members a packet is duplicated in the SD-WAN zone (2 - 4, default = 2; if set to 3, the original packet plus 2 more copies are created).
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanDuplicationArgs']]] duplications: Create SD-WAN duplication rule. The structure of `duplication` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanFailAlertInterfaceArgs']]] fail_alert_interfaces: Physical interfaces that will be alerted. The structure of `fail_alert_interfaces` block is documented below.
        :param pulumi.Input[str] fail_detect: Enable/disable SD-WAN Internet connection status checking (failure detection). Valid values: `enable`, `disable`.
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanHealthCheckArgs']]] health_checks: SD-WAN health-check.
        :param pulumi.Input[str] load_balance_mode: Algorithm or mode to use for load balancing Internet traffic to SD-WAN members. Valid values: `source-ip-based`, `weight-based`, `usage-based`, `source-dest-ip-based`, `measured-volume-based`.
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanMemberArgs']]] members: Member sequence number list. The structure of `members` block is documented below.
        :param pulumi.Input[int] neighbor_hold_boot_time: Waiting period in seconds when switching from the primary neighbor to the secondary neighbor from the neighbor start. (0 - 10000000, default = 0).
        :param pulumi.Input[str] neighbor_hold_down: Enable/disable hold switching from the secondary neighbor to the primary neighbor. Valid values: `enable`, `disable`.
        :param pulumi.Input[int] neighbor_hold_down_time: Waiting period in seconds when switching from the secondary neighbor to the primary neighbor when hold-down is disabled. (0 - 10000000, default = 0).
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanNeighborArgs']]] neighbors: Create SD-WAN neighbor from BGP neighbor table to control route advertisements according to SLA status. The structure of `neighbor` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanServiceArgs']]] services: Service and service group name. The structure of `service` block is documented below.
        :param pulumi.Input[str] status: Enable/disable SD-WAN service. Valid values: `enable`, `disable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        :param pulumi.Input[Sequence[pulumi.Input['SystemSdwanZoneArgs']]] zones: Zone name.
        """
        if duplication_max_num is not None:
            pulumi.set(__self__, "duplication_max_num", duplication_max_num)
        if duplications is not None:
            pulumi.set(__self__, "duplications", duplications)
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if fail_alert_interfaces is not None:
            pulumi.set(__self__, "fail_alert_interfaces", fail_alert_interfaces)
        if fail_detect is not None:
            pulumi.set(__self__, "fail_detect", fail_detect)
        if health_checks is not None:
            pulumi.set(__self__, "health_checks", health_checks)
        if load_balance_mode is not None:
            pulumi.set(__self__, "load_balance_mode", load_balance_mode)
        if members is not None:
            pulumi.set(__self__, "members", members)
        if neighbor_hold_boot_time is not None:
            pulumi.set(__self__, "neighbor_hold_boot_time", neighbor_hold_boot_time)
        if neighbor_hold_down is not None:
            pulumi.set(__self__, "neighbor_hold_down", neighbor_hold_down)
        if neighbor_hold_down_time is not None:
            pulumi.set(__self__, "neighbor_hold_down_time", neighbor_hold_down_time)
        if neighbors is not None:
            pulumi.set(__self__, "neighbors", neighbors)
        if services is not None:
            pulumi.set(__self__, "services", services)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)
        if zones is not None:
            pulumi.set(__self__, "zones", zones)

    @property
    @pulumi.getter(name="duplicationMaxNum")
    def duplication_max_num(self) -> Optional[pulumi.Input[int]]:
        """
        Maximum number of interface members a packet is duplicated in the SD-WAN zone (2 - 4, default = 2; if set to 3, the original packet plus 2 more copies are created).
        """
        return pulumi.get(self, "duplication_max_num")

    @duplication_max_num.setter
    def duplication_max_num(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "duplication_max_num", value)

    @property
    @pulumi.getter
    def duplications(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanDuplicationArgs']]]]:
        """
        Create SD-WAN duplication rule. The structure of `duplication` block is documented below.
        """
        return pulumi.get(self, "duplications")

    @duplications.setter
    def duplications(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanDuplicationArgs']]]]):
        pulumi.set(self, "duplications", value)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter(name="failAlertInterfaces")
    def fail_alert_interfaces(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanFailAlertInterfaceArgs']]]]:
        """
        Physical interfaces that will be alerted. The structure of `fail_alert_interfaces` block is documented below.
        """
        return pulumi.get(self, "fail_alert_interfaces")

    @fail_alert_interfaces.setter
    def fail_alert_interfaces(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanFailAlertInterfaceArgs']]]]):
        pulumi.set(self, "fail_alert_interfaces", value)

    @property
    @pulumi.getter(name="failDetect")
    def fail_detect(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable SD-WAN Internet connection status checking (failure detection). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "fail_detect")

    @fail_detect.setter
    def fail_detect(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "fail_detect", value)

    @property
    @pulumi.getter(name="healthChecks")
    def health_checks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanHealthCheckArgs']]]]:
        """
        SD-WAN health-check.
        """
        return pulumi.get(self, "health_checks")

    @health_checks.setter
    def health_checks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanHealthCheckArgs']]]]):
        pulumi.set(self, "health_checks", value)

    @property
    @pulumi.getter(name="loadBalanceMode")
    def load_balance_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Algorithm or mode to use for load balancing Internet traffic to SD-WAN members. Valid values: `source-ip-based`, `weight-based`, `usage-based`, `source-dest-ip-based`, `measured-volume-based`.
        """
        return pulumi.get(self, "load_balance_mode")

    @load_balance_mode.setter
    def load_balance_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "load_balance_mode", value)

    @property
    @pulumi.getter
    def members(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanMemberArgs']]]]:
        """
        Member sequence number list. The structure of `members` block is documented below.
        """
        return pulumi.get(self, "members")

    @members.setter
    def members(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanMemberArgs']]]]):
        pulumi.set(self, "members", value)

    @property
    @pulumi.getter(name="neighborHoldBootTime")
    def neighbor_hold_boot_time(self) -> Optional[pulumi.Input[int]]:
        """
        Waiting period in seconds when switching from the primary neighbor to the secondary neighbor from the neighbor start. (0 - 10000000, default = 0).
        """
        return pulumi.get(self, "neighbor_hold_boot_time")

    @neighbor_hold_boot_time.setter
    def neighbor_hold_boot_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "neighbor_hold_boot_time", value)

    @property
    @pulumi.getter(name="neighborHoldDown")
    def neighbor_hold_down(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable hold switching from the secondary neighbor to the primary neighbor. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "neighbor_hold_down")

    @neighbor_hold_down.setter
    def neighbor_hold_down(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "neighbor_hold_down", value)

    @property
    @pulumi.getter(name="neighborHoldDownTime")
    def neighbor_hold_down_time(self) -> Optional[pulumi.Input[int]]:
        """
        Waiting period in seconds when switching from the secondary neighbor to the primary neighbor when hold-down is disabled. (0 - 10000000, default = 0).
        """
        return pulumi.get(self, "neighbor_hold_down_time")

    @neighbor_hold_down_time.setter
    def neighbor_hold_down_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "neighbor_hold_down_time", value)

    @property
    @pulumi.getter
    def neighbors(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanNeighborArgs']]]]:
        """
        Create SD-WAN neighbor from BGP neighbor table to control route advertisements according to SLA status. The structure of `neighbor` block is documented below.
        """
        return pulumi.get(self, "neighbors")

    @neighbors.setter
    def neighbors(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanNeighborArgs']]]]):
        pulumi.set(self, "neighbors", value)

    @property
    @pulumi.getter
    def services(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanServiceArgs']]]]:
        """
        Service and service group name. The structure of `service` block is documented below.
        """
        return pulumi.get(self, "services")

    @services.setter
    def services(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanServiceArgs']]]]):
        pulumi.set(self, "services", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable SD-WAN service. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)

    @property
    @pulumi.getter
    def zones(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanZoneArgs']]]]:
        """
        Zone name.
        """
        return pulumi.get(self, "zones")

    @zones.setter
    def zones(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SystemSdwanZoneArgs']]]]):
        pulumi.set(self, "zones", value)


class SystemSdwan(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 duplication_max_num: Optional[pulumi.Input[int]] = None,
                 duplications: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanDuplicationArgs']]]]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 fail_alert_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanFailAlertInterfaceArgs']]]]] = None,
                 fail_detect: Optional[pulumi.Input[str]] = None,
                 health_checks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanHealthCheckArgs']]]]] = None,
                 load_balance_mode: Optional[pulumi.Input[str]] = None,
                 members: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanMemberArgs']]]]] = None,
                 neighbor_hold_boot_time: Optional[pulumi.Input[int]] = None,
                 neighbor_hold_down: Optional[pulumi.Input[str]] = None,
                 neighbor_hold_down_time: Optional[pulumi.Input[int]] = None,
                 neighbors: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanNeighborArgs']]]]] = None,
                 services: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanServiceArgs']]]]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 zones: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanZoneArgs']]]]] = None,
                 __props__=None):
        """
        Configure redundant internet connections using SD-WAN (formerly virtual WAN link). Applies to FortiOS Version `>= 6.4.2`.

        ## Import

        System Sdwan can be imported using any of these accepted formats$ export "FORTIOS_IMPORT_TABLE"="true"

        ```sh
         $ pulumi import fortios:index/systemSdwan:SystemSdwan labelname SystemSdwan
        ```

         $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] duplication_max_num: Maximum number of interface members a packet is duplicated in the SD-WAN zone (2 - 4, default = 2; if set to 3, the original packet plus 2 more copies are created).
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanDuplicationArgs']]]] duplications: Create SD-WAN duplication rule. The structure of `duplication` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanFailAlertInterfaceArgs']]]] fail_alert_interfaces: Physical interfaces that will be alerted. The structure of `fail_alert_interfaces` block is documented below.
        :param pulumi.Input[str] fail_detect: Enable/disable SD-WAN Internet connection status checking (failure detection). Valid values: `enable`, `disable`.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanHealthCheckArgs']]]] health_checks: SD-WAN health-check.
        :param pulumi.Input[str] load_balance_mode: Algorithm or mode to use for load balancing Internet traffic to SD-WAN members. Valid values: `source-ip-based`, `weight-based`, `usage-based`, `source-dest-ip-based`, `measured-volume-based`.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanMemberArgs']]]] members: Member sequence number list. The structure of `members` block is documented below.
        :param pulumi.Input[int] neighbor_hold_boot_time: Waiting period in seconds when switching from the primary neighbor to the secondary neighbor from the neighbor start. (0 - 10000000, default = 0).
        :param pulumi.Input[str] neighbor_hold_down: Enable/disable hold switching from the secondary neighbor to the primary neighbor. Valid values: `enable`, `disable`.
        :param pulumi.Input[int] neighbor_hold_down_time: Waiting period in seconds when switching from the secondary neighbor to the primary neighbor when hold-down is disabled. (0 - 10000000, default = 0).
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanNeighborArgs']]]] neighbors: Create SD-WAN neighbor from BGP neighbor table to control route advertisements according to SLA status. The structure of `neighbor` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanServiceArgs']]]] services: Service and service group name. The structure of `service` block is documented below.
        :param pulumi.Input[str] status: Enable/disable SD-WAN service. Valid values: `enable`, `disable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanZoneArgs']]]] zones: Zone name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[SystemSdwanArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Configure redundant internet connections using SD-WAN (formerly virtual WAN link). Applies to FortiOS Version `>= 6.4.2`.

        ## Import

        System Sdwan can be imported using any of these accepted formats$ export "FORTIOS_IMPORT_TABLE"="true"

        ```sh
         $ pulumi import fortios:index/systemSdwan:SystemSdwan labelname SystemSdwan
        ```

         $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param SystemSdwanArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SystemSdwanArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 duplication_max_num: Optional[pulumi.Input[int]] = None,
                 duplications: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanDuplicationArgs']]]]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 fail_alert_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanFailAlertInterfaceArgs']]]]] = None,
                 fail_detect: Optional[pulumi.Input[str]] = None,
                 health_checks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanHealthCheckArgs']]]]] = None,
                 load_balance_mode: Optional[pulumi.Input[str]] = None,
                 members: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanMemberArgs']]]]] = None,
                 neighbor_hold_boot_time: Optional[pulumi.Input[int]] = None,
                 neighbor_hold_down: Optional[pulumi.Input[str]] = None,
                 neighbor_hold_down_time: Optional[pulumi.Input[int]] = None,
                 neighbors: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanNeighborArgs']]]]] = None,
                 services: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanServiceArgs']]]]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 zones: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanZoneArgs']]]]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SystemSdwanArgs.__new__(SystemSdwanArgs)

            __props__.__dict__["duplication_max_num"] = duplication_max_num
            __props__.__dict__["duplications"] = duplications
            __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
            __props__.__dict__["fail_alert_interfaces"] = fail_alert_interfaces
            __props__.__dict__["fail_detect"] = fail_detect
            __props__.__dict__["health_checks"] = health_checks
            __props__.__dict__["load_balance_mode"] = load_balance_mode
            __props__.__dict__["members"] = members
            __props__.__dict__["neighbor_hold_boot_time"] = neighbor_hold_boot_time
            __props__.__dict__["neighbor_hold_down"] = neighbor_hold_down
            __props__.__dict__["neighbor_hold_down_time"] = neighbor_hold_down_time
            __props__.__dict__["neighbors"] = neighbors
            __props__.__dict__["services"] = services
            __props__.__dict__["status"] = status
            __props__.__dict__["vdomparam"] = vdomparam
            __props__.__dict__["zones"] = zones
        super(SystemSdwan, __self__).__init__(
            'fortios:index/systemSdwan:SystemSdwan',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            duplication_max_num: Optional[pulumi.Input[int]] = None,
            duplications: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanDuplicationArgs']]]]] = None,
            dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
            fail_alert_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanFailAlertInterfaceArgs']]]]] = None,
            fail_detect: Optional[pulumi.Input[str]] = None,
            health_checks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanHealthCheckArgs']]]]] = None,
            load_balance_mode: Optional[pulumi.Input[str]] = None,
            members: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanMemberArgs']]]]] = None,
            neighbor_hold_boot_time: Optional[pulumi.Input[int]] = None,
            neighbor_hold_down: Optional[pulumi.Input[str]] = None,
            neighbor_hold_down_time: Optional[pulumi.Input[int]] = None,
            neighbors: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanNeighborArgs']]]]] = None,
            services: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanServiceArgs']]]]] = None,
            status: Optional[pulumi.Input[str]] = None,
            vdomparam: Optional[pulumi.Input[str]] = None,
            zones: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanZoneArgs']]]]] = None) -> 'SystemSdwan':
        """
        Get an existing SystemSdwan resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] duplication_max_num: Maximum number of interface members a packet is duplicated in the SD-WAN zone (2 - 4, default = 2; if set to 3, the original packet plus 2 more copies are created).
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanDuplicationArgs']]]] duplications: Create SD-WAN duplication rule. The structure of `duplication` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanFailAlertInterfaceArgs']]]] fail_alert_interfaces: Physical interfaces that will be alerted. The structure of `fail_alert_interfaces` block is documented below.
        :param pulumi.Input[str] fail_detect: Enable/disable SD-WAN Internet connection status checking (failure detection). Valid values: `enable`, `disable`.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanHealthCheckArgs']]]] health_checks: SD-WAN health-check.
        :param pulumi.Input[str] load_balance_mode: Algorithm or mode to use for load balancing Internet traffic to SD-WAN members. Valid values: `source-ip-based`, `weight-based`, `usage-based`, `source-dest-ip-based`, `measured-volume-based`.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanMemberArgs']]]] members: Member sequence number list. The structure of `members` block is documented below.
        :param pulumi.Input[int] neighbor_hold_boot_time: Waiting period in seconds when switching from the primary neighbor to the secondary neighbor from the neighbor start. (0 - 10000000, default = 0).
        :param pulumi.Input[str] neighbor_hold_down: Enable/disable hold switching from the secondary neighbor to the primary neighbor. Valid values: `enable`, `disable`.
        :param pulumi.Input[int] neighbor_hold_down_time: Waiting period in seconds when switching from the secondary neighbor to the primary neighbor when hold-down is disabled. (0 - 10000000, default = 0).
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanNeighborArgs']]]] neighbors: Create SD-WAN neighbor from BGP neighbor table to control route advertisements according to SLA status. The structure of `neighbor` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanServiceArgs']]]] services: Service and service group name. The structure of `service` block is documented below.
        :param pulumi.Input[str] status: Enable/disable SD-WAN service. Valid values: `enable`, `disable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SystemSdwanZoneArgs']]]] zones: Zone name.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SystemSdwanState.__new__(_SystemSdwanState)

        __props__.__dict__["duplication_max_num"] = duplication_max_num
        __props__.__dict__["duplications"] = duplications
        __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
        __props__.__dict__["fail_alert_interfaces"] = fail_alert_interfaces
        __props__.__dict__["fail_detect"] = fail_detect
        __props__.__dict__["health_checks"] = health_checks
        __props__.__dict__["load_balance_mode"] = load_balance_mode
        __props__.__dict__["members"] = members
        __props__.__dict__["neighbor_hold_boot_time"] = neighbor_hold_boot_time
        __props__.__dict__["neighbor_hold_down"] = neighbor_hold_down
        __props__.__dict__["neighbor_hold_down_time"] = neighbor_hold_down_time
        __props__.__dict__["neighbors"] = neighbors
        __props__.__dict__["services"] = services
        __props__.__dict__["status"] = status
        __props__.__dict__["vdomparam"] = vdomparam
        __props__.__dict__["zones"] = zones
        return SystemSdwan(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="duplicationMaxNum")
    def duplication_max_num(self) -> pulumi.Output[int]:
        """
        Maximum number of interface members a packet is duplicated in the SD-WAN zone (2 - 4, default = 2; if set to 3, the original packet plus 2 more copies are created).
        """
        return pulumi.get(self, "duplication_max_num")

    @property
    @pulumi.getter
    def duplications(self) -> pulumi.Output[Optional[Sequence['outputs.SystemSdwanDuplication']]]:
        """
        Create SD-WAN duplication rule. The structure of `duplication` block is documented below.
        """
        return pulumi.get(self, "duplications")

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> pulumi.Output[Optional[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @property
    @pulumi.getter(name="failAlertInterfaces")
    def fail_alert_interfaces(self) -> pulumi.Output[Optional[Sequence['outputs.SystemSdwanFailAlertInterface']]]:
        """
        Physical interfaces that will be alerted. The structure of `fail_alert_interfaces` block is documented below.
        """
        return pulumi.get(self, "fail_alert_interfaces")

    @property
    @pulumi.getter(name="failDetect")
    def fail_detect(self) -> pulumi.Output[str]:
        """
        Enable/disable SD-WAN Internet connection status checking (failure detection). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "fail_detect")

    @property
    @pulumi.getter(name="healthChecks")
    def health_checks(self) -> pulumi.Output[Optional[Sequence['outputs.SystemSdwanHealthCheck']]]:
        """
        SD-WAN health-check.
        """
        return pulumi.get(self, "health_checks")

    @property
    @pulumi.getter(name="loadBalanceMode")
    def load_balance_mode(self) -> pulumi.Output[str]:
        """
        Algorithm or mode to use for load balancing Internet traffic to SD-WAN members. Valid values: `source-ip-based`, `weight-based`, `usage-based`, `source-dest-ip-based`, `measured-volume-based`.
        """
        return pulumi.get(self, "load_balance_mode")

    @property
    @pulumi.getter
    def members(self) -> pulumi.Output[Optional[Sequence['outputs.SystemSdwanMember']]]:
        """
        Member sequence number list. The structure of `members` block is documented below.
        """
        return pulumi.get(self, "members")

    @property
    @pulumi.getter(name="neighborHoldBootTime")
    def neighbor_hold_boot_time(self) -> pulumi.Output[int]:
        """
        Waiting period in seconds when switching from the primary neighbor to the secondary neighbor from the neighbor start. (0 - 10000000, default = 0).
        """
        return pulumi.get(self, "neighbor_hold_boot_time")

    @property
    @pulumi.getter(name="neighborHoldDown")
    def neighbor_hold_down(self) -> pulumi.Output[str]:
        """
        Enable/disable hold switching from the secondary neighbor to the primary neighbor. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "neighbor_hold_down")

    @property
    @pulumi.getter(name="neighborHoldDownTime")
    def neighbor_hold_down_time(self) -> pulumi.Output[int]:
        """
        Waiting period in seconds when switching from the secondary neighbor to the primary neighbor when hold-down is disabled. (0 - 10000000, default = 0).
        """
        return pulumi.get(self, "neighbor_hold_down_time")

    @property
    @pulumi.getter
    def neighbors(self) -> pulumi.Output[Optional[Sequence['outputs.SystemSdwanNeighbor']]]:
        """
        Create SD-WAN neighbor from BGP neighbor table to control route advertisements according to SLA status. The structure of `neighbor` block is documented below.
        """
        return pulumi.get(self, "neighbors")

    @property
    @pulumi.getter
    def services(self) -> pulumi.Output[Optional[Sequence['outputs.SystemSdwanService']]]:
        """
        Service and service group name. The structure of `service` block is documented below.
        """
        return pulumi.get(self, "services")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        Enable/disable SD-WAN service. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def vdomparam(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @property
    @pulumi.getter
    def zones(self) -> pulumi.Output[Optional[Sequence['outputs.SystemSdwanZone']]]:
        """
        Zone name.
        """
        return pulumi.get(self, "zones")

