# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['VpnCertificateLocalArgs', 'VpnCertificateLocal']

@pulumi.input_type
class VpnCertificateLocalArgs:
    def __init__(__self__, *,
                 private_key: pulumi.Input[str],
                 auto_regenerate_days: Optional[pulumi.Input[int]] = None,
                 auto_regenerate_days_warning: Optional[pulumi.Input[int]] = None,
                 ca_identifier: Optional[pulumi.Input[str]] = None,
                 certificate: Optional[pulumi.Input[str]] = None,
                 cmp_path: Optional[pulumi.Input[str]] = None,
                 cmp_regeneration_method: Optional[pulumi.Input[str]] = None,
                 cmp_server: Optional[pulumi.Input[str]] = None,
                 cmp_server_cert: Optional[pulumi.Input[str]] = None,
                 comments: Optional[pulumi.Input[str]] = None,
                 csr: Optional[pulumi.Input[str]] = None,
                 enroll_protocol: Optional[pulumi.Input[str]] = None,
                 ike_localid: Optional[pulumi.Input[str]] = None,
                 ike_localid_type: Optional[pulumi.Input[str]] = None,
                 last_updated: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 name_encoding: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 range: Optional[pulumi.Input[str]] = None,
                 scep_password: Optional[pulumi.Input[str]] = None,
                 scep_url: Optional[pulumi.Input[str]] = None,
                 source: Optional[pulumi.Input[str]] = None,
                 source_ip: Optional[pulumi.Input[str]] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a VpnCertificateLocal resource.
        :param pulumi.Input[str] private_key: PEM format key, encrypted with a password.
        :param pulumi.Input[int] auto_regenerate_days: Number of days to wait before expiry of an updated local certificate is requested (0 = disabled).
        :param pulumi.Input[int] auto_regenerate_days_warning: Number of days to wait before an expiry warning message is generated (0 = disabled).
        :param pulumi.Input[str] ca_identifier: CA identifier of the CA server for signing via SCEP.
        :param pulumi.Input[str] certificate: PEM format certificate.
        :param pulumi.Input[str] cmp_path: Path location inside CMP server.
        :param pulumi.Input[str] cmp_regeneration_method: CMP auto-regeneration method. Valid values: `keyupate`, `renewal`.
        :param pulumi.Input[str] cmp_server: 'ADDRESS:PORT' for CMP server.
        :param pulumi.Input[str] cmp_server_cert: CMP server certificate.
        :param pulumi.Input[str] comments: Comment.
        :param pulumi.Input[str] csr: Certificate Signing Request.
        :param pulumi.Input[str] enroll_protocol: Certificate enrollment protocol. Valid values: `none`, `scep`, `cmpv2`.
        :param pulumi.Input[str] ike_localid: Local ID the FortiGate uses for authentication as a VPN client.
        :param pulumi.Input[str] ike_localid_type: IKE local ID type. Valid values: `asn1dn`, `fqdn`.
        :param pulumi.Input[int] last_updated: Time at which certificate was last updated.
        :param pulumi.Input[str] name: Name.
        :param pulumi.Input[str] name_encoding: Name encoding method for auto-regeneration. Valid values: `printable`, `utf8`.
        :param pulumi.Input[str] password: Password as a PEM file.
        :param pulumi.Input[str] range: Either a global or VDOM IP address range for the certificate. Valid values: `global`, `vdom`.
        :param pulumi.Input[str] scep_password: SCEP server challenge password for auto-regeneration.
        :param pulumi.Input[str] scep_url: SCEP server URL.
        :param pulumi.Input[str] source: Certificate source type.
        :param pulumi.Input[str] source_ip: Source IP address for communications to the SCEP server.
        :param pulumi.Input[str] state: Certificate Signing Request State.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        pulumi.set(__self__, "private_key", private_key)
        if auto_regenerate_days is not None:
            pulumi.set(__self__, "auto_regenerate_days", auto_regenerate_days)
        if auto_regenerate_days_warning is not None:
            pulumi.set(__self__, "auto_regenerate_days_warning", auto_regenerate_days_warning)
        if ca_identifier is not None:
            pulumi.set(__self__, "ca_identifier", ca_identifier)
        if certificate is not None:
            pulumi.set(__self__, "certificate", certificate)
        if cmp_path is not None:
            pulumi.set(__self__, "cmp_path", cmp_path)
        if cmp_regeneration_method is not None:
            pulumi.set(__self__, "cmp_regeneration_method", cmp_regeneration_method)
        if cmp_server is not None:
            pulumi.set(__self__, "cmp_server", cmp_server)
        if cmp_server_cert is not None:
            pulumi.set(__self__, "cmp_server_cert", cmp_server_cert)
        if comments is not None:
            pulumi.set(__self__, "comments", comments)
        if csr is not None:
            pulumi.set(__self__, "csr", csr)
        if enroll_protocol is not None:
            pulumi.set(__self__, "enroll_protocol", enroll_protocol)
        if ike_localid is not None:
            pulumi.set(__self__, "ike_localid", ike_localid)
        if ike_localid_type is not None:
            pulumi.set(__self__, "ike_localid_type", ike_localid_type)
        if last_updated is not None:
            pulumi.set(__self__, "last_updated", last_updated)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if name_encoding is not None:
            pulumi.set(__self__, "name_encoding", name_encoding)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if range is not None:
            pulumi.set(__self__, "range", range)
        if scep_password is not None:
            pulumi.set(__self__, "scep_password", scep_password)
        if scep_url is not None:
            pulumi.set(__self__, "scep_url", scep_url)
        if source is not None:
            pulumi.set(__self__, "source", source)
        if source_ip is not None:
            pulumi.set(__self__, "source_ip", source_ip)
        if state is not None:
            pulumi.set(__self__, "state", state)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> pulumi.Input[str]:
        """
        PEM format key, encrypted with a password.
        """
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: pulumi.Input[str]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter(name="autoRegenerateDays")
    def auto_regenerate_days(self) -> Optional[pulumi.Input[int]]:
        """
        Number of days to wait before expiry of an updated local certificate is requested (0 = disabled).
        """
        return pulumi.get(self, "auto_regenerate_days")

    @auto_regenerate_days.setter
    def auto_regenerate_days(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "auto_regenerate_days", value)

    @property
    @pulumi.getter(name="autoRegenerateDaysWarning")
    def auto_regenerate_days_warning(self) -> Optional[pulumi.Input[int]]:
        """
        Number of days to wait before an expiry warning message is generated (0 = disabled).
        """
        return pulumi.get(self, "auto_regenerate_days_warning")

    @auto_regenerate_days_warning.setter
    def auto_regenerate_days_warning(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "auto_regenerate_days_warning", value)

    @property
    @pulumi.getter(name="caIdentifier")
    def ca_identifier(self) -> Optional[pulumi.Input[str]]:
        """
        CA identifier of the CA server for signing via SCEP.
        """
        return pulumi.get(self, "ca_identifier")

    @ca_identifier.setter
    def ca_identifier(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ca_identifier", value)

    @property
    @pulumi.getter
    def certificate(self) -> Optional[pulumi.Input[str]]:
        """
        PEM format certificate.
        """
        return pulumi.get(self, "certificate")

    @certificate.setter
    def certificate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "certificate", value)

    @property
    @pulumi.getter(name="cmpPath")
    def cmp_path(self) -> Optional[pulumi.Input[str]]:
        """
        Path location inside CMP server.
        """
        return pulumi.get(self, "cmp_path")

    @cmp_path.setter
    def cmp_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cmp_path", value)

    @property
    @pulumi.getter(name="cmpRegenerationMethod")
    def cmp_regeneration_method(self) -> Optional[pulumi.Input[str]]:
        """
        CMP auto-regeneration method. Valid values: `keyupate`, `renewal`.
        """
        return pulumi.get(self, "cmp_regeneration_method")

    @cmp_regeneration_method.setter
    def cmp_regeneration_method(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cmp_regeneration_method", value)

    @property
    @pulumi.getter(name="cmpServer")
    def cmp_server(self) -> Optional[pulumi.Input[str]]:
        """
        'ADDRESS:PORT' for CMP server.
        """
        return pulumi.get(self, "cmp_server")

    @cmp_server.setter
    def cmp_server(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cmp_server", value)

    @property
    @pulumi.getter(name="cmpServerCert")
    def cmp_server_cert(self) -> Optional[pulumi.Input[str]]:
        """
        CMP server certificate.
        """
        return pulumi.get(self, "cmp_server_cert")

    @cmp_server_cert.setter
    def cmp_server_cert(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cmp_server_cert", value)

    @property
    @pulumi.getter
    def comments(self) -> Optional[pulumi.Input[str]]:
        """
        Comment.
        """
        return pulumi.get(self, "comments")

    @comments.setter
    def comments(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comments", value)

    @property
    @pulumi.getter
    def csr(self) -> Optional[pulumi.Input[str]]:
        """
        Certificate Signing Request.
        """
        return pulumi.get(self, "csr")

    @csr.setter
    def csr(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "csr", value)

    @property
    @pulumi.getter(name="enrollProtocol")
    def enroll_protocol(self) -> Optional[pulumi.Input[str]]:
        """
        Certificate enrollment protocol. Valid values: `none`, `scep`, `cmpv2`.
        """
        return pulumi.get(self, "enroll_protocol")

    @enroll_protocol.setter
    def enroll_protocol(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enroll_protocol", value)

    @property
    @pulumi.getter(name="ikeLocalid")
    def ike_localid(self) -> Optional[pulumi.Input[str]]:
        """
        Local ID the FortiGate uses for authentication as a VPN client.
        """
        return pulumi.get(self, "ike_localid")

    @ike_localid.setter
    def ike_localid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ike_localid", value)

    @property
    @pulumi.getter(name="ikeLocalidType")
    def ike_localid_type(self) -> Optional[pulumi.Input[str]]:
        """
        IKE local ID type. Valid values: `asn1dn`, `fqdn`.
        """
        return pulumi.get(self, "ike_localid_type")

    @ike_localid_type.setter
    def ike_localid_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ike_localid_type", value)

    @property
    @pulumi.getter(name="lastUpdated")
    def last_updated(self) -> Optional[pulumi.Input[int]]:
        """
        Time at which certificate was last updated.
        """
        return pulumi.get(self, "last_updated")

    @last_updated.setter
    def last_updated(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "last_updated", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="nameEncoding")
    def name_encoding(self) -> Optional[pulumi.Input[str]]:
        """
        Name encoding method for auto-regeneration. Valid values: `printable`, `utf8`.
        """
        return pulumi.get(self, "name_encoding")

    @name_encoding.setter
    def name_encoding(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name_encoding", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[str]]:
        """
        Password as a PEM file.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter
    def range(self) -> Optional[pulumi.Input[str]]:
        """
        Either a global or VDOM IP address range for the certificate. Valid values: `global`, `vdom`.
        """
        return pulumi.get(self, "range")

    @range.setter
    def range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "range", value)

    @property
    @pulumi.getter(name="scepPassword")
    def scep_password(self) -> Optional[pulumi.Input[str]]:
        """
        SCEP server challenge password for auto-regeneration.
        """
        return pulumi.get(self, "scep_password")

    @scep_password.setter
    def scep_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scep_password", value)

    @property
    @pulumi.getter(name="scepUrl")
    def scep_url(self) -> Optional[pulumi.Input[str]]:
        """
        SCEP server URL.
        """
        return pulumi.get(self, "scep_url")

    @scep_url.setter
    def scep_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scep_url", value)

    @property
    @pulumi.getter
    def source(self) -> Optional[pulumi.Input[str]]:
        """
        Certificate source type.
        """
        return pulumi.get(self, "source")

    @source.setter
    def source(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source", value)

    @property
    @pulumi.getter(name="sourceIp")
    def source_ip(self) -> Optional[pulumi.Input[str]]:
        """
        Source IP address for communications to the SCEP server.
        """
        return pulumi.get(self, "source_ip")

    @source_ip.setter
    def source_ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source_ip", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[str]]:
        """
        Certificate Signing Request State.
        """
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "state", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


@pulumi.input_type
class _VpnCertificateLocalState:
    def __init__(__self__, *,
                 auto_regenerate_days: Optional[pulumi.Input[int]] = None,
                 auto_regenerate_days_warning: Optional[pulumi.Input[int]] = None,
                 ca_identifier: Optional[pulumi.Input[str]] = None,
                 certificate: Optional[pulumi.Input[str]] = None,
                 cmp_path: Optional[pulumi.Input[str]] = None,
                 cmp_regeneration_method: Optional[pulumi.Input[str]] = None,
                 cmp_server: Optional[pulumi.Input[str]] = None,
                 cmp_server_cert: Optional[pulumi.Input[str]] = None,
                 comments: Optional[pulumi.Input[str]] = None,
                 csr: Optional[pulumi.Input[str]] = None,
                 enroll_protocol: Optional[pulumi.Input[str]] = None,
                 ike_localid: Optional[pulumi.Input[str]] = None,
                 ike_localid_type: Optional[pulumi.Input[str]] = None,
                 last_updated: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 name_encoding: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 range: Optional[pulumi.Input[str]] = None,
                 scep_password: Optional[pulumi.Input[str]] = None,
                 scep_url: Optional[pulumi.Input[str]] = None,
                 source: Optional[pulumi.Input[str]] = None,
                 source_ip: Optional[pulumi.Input[str]] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering VpnCertificateLocal resources.
        :param pulumi.Input[int] auto_regenerate_days: Number of days to wait before expiry of an updated local certificate is requested (0 = disabled).
        :param pulumi.Input[int] auto_regenerate_days_warning: Number of days to wait before an expiry warning message is generated (0 = disabled).
        :param pulumi.Input[str] ca_identifier: CA identifier of the CA server for signing via SCEP.
        :param pulumi.Input[str] certificate: PEM format certificate.
        :param pulumi.Input[str] cmp_path: Path location inside CMP server.
        :param pulumi.Input[str] cmp_regeneration_method: CMP auto-regeneration method. Valid values: `keyupate`, `renewal`.
        :param pulumi.Input[str] cmp_server: 'ADDRESS:PORT' for CMP server.
        :param pulumi.Input[str] cmp_server_cert: CMP server certificate.
        :param pulumi.Input[str] comments: Comment.
        :param pulumi.Input[str] csr: Certificate Signing Request.
        :param pulumi.Input[str] enroll_protocol: Certificate enrollment protocol. Valid values: `none`, `scep`, `cmpv2`.
        :param pulumi.Input[str] ike_localid: Local ID the FortiGate uses for authentication as a VPN client.
        :param pulumi.Input[str] ike_localid_type: IKE local ID type. Valid values: `asn1dn`, `fqdn`.
        :param pulumi.Input[int] last_updated: Time at which certificate was last updated.
        :param pulumi.Input[str] name: Name.
        :param pulumi.Input[str] name_encoding: Name encoding method for auto-regeneration. Valid values: `printable`, `utf8`.
        :param pulumi.Input[str] password: Password as a PEM file.
        :param pulumi.Input[str] private_key: PEM format key, encrypted with a password.
        :param pulumi.Input[str] range: Either a global or VDOM IP address range for the certificate. Valid values: `global`, `vdom`.
        :param pulumi.Input[str] scep_password: SCEP server challenge password for auto-regeneration.
        :param pulumi.Input[str] scep_url: SCEP server URL.
        :param pulumi.Input[str] source: Certificate source type.
        :param pulumi.Input[str] source_ip: Source IP address for communications to the SCEP server.
        :param pulumi.Input[str] state: Certificate Signing Request State.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if auto_regenerate_days is not None:
            pulumi.set(__self__, "auto_regenerate_days", auto_regenerate_days)
        if auto_regenerate_days_warning is not None:
            pulumi.set(__self__, "auto_regenerate_days_warning", auto_regenerate_days_warning)
        if ca_identifier is not None:
            pulumi.set(__self__, "ca_identifier", ca_identifier)
        if certificate is not None:
            pulumi.set(__self__, "certificate", certificate)
        if cmp_path is not None:
            pulumi.set(__self__, "cmp_path", cmp_path)
        if cmp_regeneration_method is not None:
            pulumi.set(__self__, "cmp_regeneration_method", cmp_regeneration_method)
        if cmp_server is not None:
            pulumi.set(__self__, "cmp_server", cmp_server)
        if cmp_server_cert is not None:
            pulumi.set(__self__, "cmp_server_cert", cmp_server_cert)
        if comments is not None:
            pulumi.set(__self__, "comments", comments)
        if csr is not None:
            pulumi.set(__self__, "csr", csr)
        if enroll_protocol is not None:
            pulumi.set(__self__, "enroll_protocol", enroll_protocol)
        if ike_localid is not None:
            pulumi.set(__self__, "ike_localid", ike_localid)
        if ike_localid_type is not None:
            pulumi.set(__self__, "ike_localid_type", ike_localid_type)
        if last_updated is not None:
            pulumi.set(__self__, "last_updated", last_updated)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if name_encoding is not None:
            pulumi.set(__self__, "name_encoding", name_encoding)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if private_key is not None:
            pulumi.set(__self__, "private_key", private_key)
        if range is not None:
            pulumi.set(__self__, "range", range)
        if scep_password is not None:
            pulumi.set(__self__, "scep_password", scep_password)
        if scep_url is not None:
            pulumi.set(__self__, "scep_url", scep_url)
        if source is not None:
            pulumi.set(__self__, "source", source)
        if source_ip is not None:
            pulumi.set(__self__, "source_ip", source_ip)
        if state is not None:
            pulumi.set(__self__, "state", state)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter(name="autoRegenerateDays")
    def auto_regenerate_days(self) -> Optional[pulumi.Input[int]]:
        """
        Number of days to wait before expiry of an updated local certificate is requested (0 = disabled).
        """
        return pulumi.get(self, "auto_regenerate_days")

    @auto_regenerate_days.setter
    def auto_regenerate_days(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "auto_regenerate_days", value)

    @property
    @pulumi.getter(name="autoRegenerateDaysWarning")
    def auto_regenerate_days_warning(self) -> Optional[pulumi.Input[int]]:
        """
        Number of days to wait before an expiry warning message is generated (0 = disabled).
        """
        return pulumi.get(self, "auto_regenerate_days_warning")

    @auto_regenerate_days_warning.setter
    def auto_regenerate_days_warning(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "auto_regenerate_days_warning", value)

    @property
    @pulumi.getter(name="caIdentifier")
    def ca_identifier(self) -> Optional[pulumi.Input[str]]:
        """
        CA identifier of the CA server for signing via SCEP.
        """
        return pulumi.get(self, "ca_identifier")

    @ca_identifier.setter
    def ca_identifier(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ca_identifier", value)

    @property
    @pulumi.getter
    def certificate(self) -> Optional[pulumi.Input[str]]:
        """
        PEM format certificate.
        """
        return pulumi.get(self, "certificate")

    @certificate.setter
    def certificate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "certificate", value)

    @property
    @pulumi.getter(name="cmpPath")
    def cmp_path(self) -> Optional[pulumi.Input[str]]:
        """
        Path location inside CMP server.
        """
        return pulumi.get(self, "cmp_path")

    @cmp_path.setter
    def cmp_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cmp_path", value)

    @property
    @pulumi.getter(name="cmpRegenerationMethod")
    def cmp_regeneration_method(self) -> Optional[pulumi.Input[str]]:
        """
        CMP auto-regeneration method. Valid values: `keyupate`, `renewal`.
        """
        return pulumi.get(self, "cmp_regeneration_method")

    @cmp_regeneration_method.setter
    def cmp_regeneration_method(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cmp_regeneration_method", value)

    @property
    @pulumi.getter(name="cmpServer")
    def cmp_server(self) -> Optional[pulumi.Input[str]]:
        """
        'ADDRESS:PORT' for CMP server.
        """
        return pulumi.get(self, "cmp_server")

    @cmp_server.setter
    def cmp_server(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cmp_server", value)

    @property
    @pulumi.getter(name="cmpServerCert")
    def cmp_server_cert(self) -> Optional[pulumi.Input[str]]:
        """
        CMP server certificate.
        """
        return pulumi.get(self, "cmp_server_cert")

    @cmp_server_cert.setter
    def cmp_server_cert(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cmp_server_cert", value)

    @property
    @pulumi.getter
    def comments(self) -> Optional[pulumi.Input[str]]:
        """
        Comment.
        """
        return pulumi.get(self, "comments")

    @comments.setter
    def comments(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comments", value)

    @property
    @pulumi.getter
    def csr(self) -> Optional[pulumi.Input[str]]:
        """
        Certificate Signing Request.
        """
        return pulumi.get(self, "csr")

    @csr.setter
    def csr(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "csr", value)

    @property
    @pulumi.getter(name="enrollProtocol")
    def enroll_protocol(self) -> Optional[pulumi.Input[str]]:
        """
        Certificate enrollment protocol. Valid values: `none`, `scep`, `cmpv2`.
        """
        return pulumi.get(self, "enroll_protocol")

    @enroll_protocol.setter
    def enroll_protocol(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enroll_protocol", value)

    @property
    @pulumi.getter(name="ikeLocalid")
    def ike_localid(self) -> Optional[pulumi.Input[str]]:
        """
        Local ID the FortiGate uses for authentication as a VPN client.
        """
        return pulumi.get(self, "ike_localid")

    @ike_localid.setter
    def ike_localid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ike_localid", value)

    @property
    @pulumi.getter(name="ikeLocalidType")
    def ike_localid_type(self) -> Optional[pulumi.Input[str]]:
        """
        IKE local ID type. Valid values: `asn1dn`, `fqdn`.
        """
        return pulumi.get(self, "ike_localid_type")

    @ike_localid_type.setter
    def ike_localid_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ike_localid_type", value)

    @property
    @pulumi.getter(name="lastUpdated")
    def last_updated(self) -> Optional[pulumi.Input[int]]:
        """
        Time at which certificate was last updated.
        """
        return pulumi.get(self, "last_updated")

    @last_updated.setter
    def last_updated(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "last_updated", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="nameEncoding")
    def name_encoding(self) -> Optional[pulumi.Input[str]]:
        """
        Name encoding method for auto-regeneration. Valid values: `printable`, `utf8`.
        """
        return pulumi.get(self, "name_encoding")

    @name_encoding.setter
    def name_encoding(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name_encoding", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[str]]:
        """
        Password as a PEM file.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> Optional[pulumi.Input[str]]:
        """
        PEM format key, encrypted with a password.
        """
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter
    def range(self) -> Optional[pulumi.Input[str]]:
        """
        Either a global or VDOM IP address range for the certificate. Valid values: `global`, `vdom`.
        """
        return pulumi.get(self, "range")

    @range.setter
    def range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "range", value)

    @property
    @pulumi.getter(name="scepPassword")
    def scep_password(self) -> Optional[pulumi.Input[str]]:
        """
        SCEP server challenge password for auto-regeneration.
        """
        return pulumi.get(self, "scep_password")

    @scep_password.setter
    def scep_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scep_password", value)

    @property
    @pulumi.getter(name="scepUrl")
    def scep_url(self) -> Optional[pulumi.Input[str]]:
        """
        SCEP server URL.
        """
        return pulumi.get(self, "scep_url")

    @scep_url.setter
    def scep_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scep_url", value)

    @property
    @pulumi.getter
    def source(self) -> Optional[pulumi.Input[str]]:
        """
        Certificate source type.
        """
        return pulumi.get(self, "source")

    @source.setter
    def source(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source", value)

    @property
    @pulumi.getter(name="sourceIp")
    def source_ip(self) -> Optional[pulumi.Input[str]]:
        """
        Source IP address for communications to the SCEP server.
        """
        return pulumi.get(self, "source_ip")

    @source_ip.setter
    def source_ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source_ip", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[str]]:
        """
        Certificate Signing Request State.
        """
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "state", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


class VpnCertificateLocal(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_regenerate_days: Optional[pulumi.Input[int]] = None,
                 auto_regenerate_days_warning: Optional[pulumi.Input[int]] = None,
                 ca_identifier: Optional[pulumi.Input[str]] = None,
                 certificate: Optional[pulumi.Input[str]] = None,
                 cmp_path: Optional[pulumi.Input[str]] = None,
                 cmp_regeneration_method: Optional[pulumi.Input[str]] = None,
                 cmp_server: Optional[pulumi.Input[str]] = None,
                 cmp_server_cert: Optional[pulumi.Input[str]] = None,
                 comments: Optional[pulumi.Input[str]] = None,
                 csr: Optional[pulumi.Input[str]] = None,
                 enroll_protocol: Optional[pulumi.Input[str]] = None,
                 ike_localid: Optional[pulumi.Input[str]] = None,
                 ike_localid_type: Optional[pulumi.Input[str]] = None,
                 last_updated: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 name_encoding: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 range: Optional[pulumi.Input[str]] = None,
                 scep_password: Optional[pulumi.Input[str]] = None,
                 scep_url: Optional[pulumi.Input[str]] = None,
                 source: Optional[pulumi.Input[str]] = None,
                 source_ip: Optional[pulumi.Input[str]] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Local keys and certificates.

        ## Import

        VpnCertificate Local can be imported using any of these accepted formats$ export "FORTIOS_IMPORT_TABLE"="true"

        ```sh
         $ pulumi import fortios:index/vpnCertificateLocal:VpnCertificateLocal labelname {{name}}
        ```

         $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] auto_regenerate_days: Number of days to wait before expiry of an updated local certificate is requested (0 = disabled).
        :param pulumi.Input[int] auto_regenerate_days_warning: Number of days to wait before an expiry warning message is generated (0 = disabled).
        :param pulumi.Input[str] ca_identifier: CA identifier of the CA server for signing via SCEP.
        :param pulumi.Input[str] certificate: PEM format certificate.
        :param pulumi.Input[str] cmp_path: Path location inside CMP server.
        :param pulumi.Input[str] cmp_regeneration_method: CMP auto-regeneration method. Valid values: `keyupate`, `renewal`.
        :param pulumi.Input[str] cmp_server: 'ADDRESS:PORT' for CMP server.
        :param pulumi.Input[str] cmp_server_cert: CMP server certificate.
        :param pulumi.Input[str] comments: Comment.
        :param pulumi.Input[str] csr: Certificate Signing Request.
        :param pulumi.Input[str] enroll_protocol: Certificate enrollment protocol. Valid values: `none`, `scep`, `cmpv2`.
        :param pulumi.Input[str] ike_localid: Local ID the FortiGate uses for authentication as a VPN client.
        :param pulumi.Input[str] ike_localid_type: IKE local ID type. Valid values: `asn1dn`, `fqdn`.
        :param pulumi.Input[int] last_updated: Time at which certificate was last updated.
        :param pulumi.Input[str] name: Name.
        :param pulumi.Input[str] name_encoding: Name encoding method for auto-regeneration. Valid values: `printable`, `utf8`.
        :param pulumi.Input[str] password: Password as a PEM file.
        :param pulumi.Input[str] private_key: PEM format key, encrypted with a password.
        :param pulumi.Input[str] range: Either a global or VDOM IP address range for the certificate. Valid values: `global`, `vdom`.
        :param pulumi.Input[str] scep_password: SCEP server challenge password for auto-regeneration.
        :param pulumi.Input[str] scep_url: SCEP server URL.
        :param pulumi.Input[str] source: Certificate source type.
        :param pulumi.Input[str] source_ip: Source IP address for communications to the SCEP server.
        :param pulumi.Input[str] state: Certificate Signing Request State.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VpnCertificateLocalArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Local keys and certificates.

        ## Import

        VpnCertificate Local can be imported using any of these accepted formats$ export "FORTIOS_IMPORT_TABLE"="true"

        ```sh
         $ pulumi import fortios:index/vpnCertificateLocal:VpnCertificateLocal labelname {{name}}
        ```

         $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param VpnCertificateLocalArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VpnCertificateLocalArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 auto_regenerate_days: Optional[pulumi.Input[int]] = None,
                 auto_regenerate_days_warning: Optional[pulumi.Input[int]] = None,
                 ca_identifier: Optional[pulumi.Input[str]] = None,
                 certificate: Optional[pulumi.Input[str]] = None,
                 cmp_path: Optional[pulumi.Input[str]] = None,
                 cmp_regeneration_method: Optional[pulumi.Input[str]] = None,
                 cmp_server: Optional[pulumi.Input[str]] = None,
                 cmp_server_cert: Optional[pulumi.Input[str]] = None,
                 comments: Optional[pulumi.Input[str]] = None,
                 csr: Optional[pulumi.Input[str]] = None,
                 enroll_protocol: Optional[pulumi.Input[str]] = None,
                 ike_localid: Optional[pulumi.Input[str]] = None,
                 ike_localid_type: Optional[pulumi.Input[str]] = None,
                 last_updated: Optional[pulumi.Input[int]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 name_encoding: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 range: Optional[pulumi.Input[str]] = None,
                 scep_password: Optional[pulumi.Input[str]] = None,
                 scep_url: Optional[pulumi.Input[str]] = None,
                 source: Optional[pulumi.Input[str]] = None,
                 source_ip: Optional[pulumi.Input[str]] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VpnCertificateLocalArgs.__new__(VpnCertificateLocalArgs)

            __props__.__dict__["auto_regenerate_days"] = auto_regenerate_days
            __props__.__dict__["auto_regenerate_days_warning"] = auto_regenerate_days_warning
            __props__.__dict__["ca_identifier"] = ca_identifier
            __props__.__dict__["certificate"] = certificate
            __props__.__dict__["cmp_path"] = cmp_path
            __props__.__dict__["cmp_regeneration_method"] = cmp_regeneration_method
            __props__.__dict__["cmp_server"] = cmp_server
            __props__.__dict__["cmp_server_cert"] = cmp_server_cert
            __props__.__dict__["comments"] = comments
            __props__.__dict__["csr"] = csr
            __props__.__dict__["enroll_protocol"] = enroll_protocol
            __props__.__dict__["ike_localid"] = ike_localid
            __props__.__dict__["ike_localid_type"] = ike_localid_type
            __props__.__dict__["last_updated"] = last_updated
            __props__.__dict__["name"] = name
            __props__.__dict__["name_encoding"] = name_encoding
            __props__.__dict__["password"] = password
            if private_key is None and not opts.urn:
                raise TypeError("Missing required property 'private_key'")
            __props__.__dict__["private_key"] = private_key
            __props__.__dict__["range"] = range
            __props__.__dict__["scep_password"] = scep_password
            __props__.__dict__["scep_url"] = scep_url
            __props__.__dict__["source"] = source
            __props__.__dict__["source_ip"] = source_ip
            __props__.__dict__["state"] = state
            __props__.__dict__["vdomparam"] = vdomparam
        super(VpnCertificateLocal, __self__).__init__(
            'fortios:index/vpnCertificateLocal:VpnCertificateLocal',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            auto_regenerate_days: Optional[pulumi.Input[int]] = None,
            auto_regenerate_days_warning: Optional[pulumi.Input[int]] = None,
            ca_identifier: Optional[pulumi.Input[str]] = None,
            certificate: Optional[pulumi.Input[str]] = None,
            cmp_path: Optional[pulumi.Input[str]] = None,
            cmp_regeneration_method: Optional[pulumi.Input[str]] = None,
            cmp_server: Optional[pulumi.Input[str]] = None,
            cmp_server_cert: Optional[pulumi.Input[str]] = None,
            comments: Optional[pulumi.Input[str]] = None,
            csr: Optional[pulumi.Input[str]] = None,
            enroll_protocol: Optional[pulumi.Input[str]] = None,
            ike_localid: Optional[pulumi.Input[str]] = None,
            ike_localid_type: Optional[pulumi.Input[str]] = None,
            last_updated: Optional[pulumi.Input[int]] = None,
            name: Optional[pulumi.Input[str]] = None,
            name_encoding: Optional[pulumi.Input[str]] = None,
            password: Optional[pulumi.Input[str]] = None,
            private_key: Optional[pulumi.Input[str]] = None,
            range: Optional[pulumi.Input[str]] = None,
            scep_password: Optional[pulumi.Input[str]] = None,
            scep_url: Optional[pulumi.Input[str]] = None,
            source: Optional[pulumi.Input[str]] = None,
            source_ip: Optional[pulumi.Input[str]] = None,
            state: Optional[pulumi.Input[str]] = None,
            vdomparam: Optional[pulumi.Input[str]] = None) -> 'VpnCertificateLocal':
        """
        Get an existing VpnCertificateLocal resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] auto_regenerate_days: Number of days to wait before expiry of an updated local certificate is requested (0 = disabled).
        :param pulumi.Input[int] auto_regenerate_days_warning: Number of days to wait before an expiry warning message is generated (0 = disabled).
        :param pulumi.Input[str] ca_identifier: CA identifier of the CA server for signing via SCEP.
        :param pulumi.Input[str] certificate: PEM format certificate.
        :param pulumi.Input[str] cmp_path: Path location inside CMP server.
        :param pulumi.Input[str] cmp_regeneration_method: CMP auto-regeneration method. Valid values: `keyupate`, `renewal`.
        :param pulumi.Input[str] cmp_server: 'ADDRESS:PORT' for CMP server.
        :param pulumi.Input[str] cmp_server_cert: CMP server certificate.
        :param pulumi.Input[str] comments: Comment.
        :param pulumi.Input[str] csr: Certificate Signing Request.
        :param pulumi.Input[str] enroll_protocol: Certificate enrollment protocol. Valid values: `none`, `scep`, `cmpv2`.
        :param pulumi.Input[str] ike_localid: Local ID the FortiGate uses for authentication as a VPN client.
        :param pulumi.Input[str] ike_localid_type: IKE local ID type. Valid values: `asn1dn`, `fqdn`.
        :param pulumi.Input[int] last_updated: Time at which certificate was last updated.
        :param pulumi.Input[str] name: Name.
        :param pulumi.Input[str] name_encoding: Name encoding method for auto-regeneration. Valid values: `printable`, `utf8`.
        :param pulumi.Input[str] password: Password as a PEM file.
        :param pulumi.Input[str] private_key: PEM format key, encrypted with a password.
        :param pulumi.Input[str] range: Either a global or VDOM IP address range for the certificate. Valid values: `global`, `vdom`.
        :param pulumi.Input[str] scep_password: SCEP server challenge password for auto-regeneration.
        :param pulumi.Input[str] scep_url: SCEP server URL.
        :param pulumi.Input[str] source: Certificate source type.
        :param pulumi.Input[str] source_ip: Source IP address for communications to the SCEP server.
        :param pulumi.Input[str] state: Certificate Signing Request State.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _VpnCertificateLocalState.__new__(_VpnCertificateLocalState)

        __props__.__dict__["auto_regenerate_days"] = auto_regenerate_days
        __props__.__dict__["auto_regenerate_days_warning"] = auto_regenerate_days_warning
        __props__.__dict__["ca_identifier"] = ca_identifier
        __props__.__dict__["certificate"] = certificate
        __props__.__dict__["cmp_path"] = cmp_path
        __props__.__dict__["cmp_regeneration_method"] = cmp_regeneration_method
        __props__.__dict__["cmp_server"] = cmp_server
        __props__.__dict__["cmp_server_cert"] = cmp_server_cert
        __props__.__dict__["comments"] = comments
        __props__.__dict__["csr"] = csr
        __props__.__dict__["enroll_protocol"] = enroll_protocol
        __props__.__dict__["ike_localid"] = ike_localid
        __props__.__dict__["ike_localid_type"] = ike_localid_type
        __props__.__dict__["last_updated"] = last_updated
        __props__.__dict__["name"] = name
        __props__.__dict__["name_encoding"] = name_encoding
        __props__.__dict__["password"] = password
        __props__.__dict__["private_key"] = private_key
        __props__.__dict__["range"] = range
        __props__.__dict__["scep_password"] = scep_password
        __props__.__dict__["scep_url"] = scep_url
        __props__.__dict__["source"] = source
        __props__.__dict__["source_ip"] = source_ip
        __props__.__dict__["state"] = state
        __props__.__dict__["vdomparam"] = vdomparam
        return VpnCertificateLocal(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="autoRegenerateDays")
    def auto_regenerate_days(self) -> pulumi.Output[int]:
        """
        Number of days to wait before expiry of an updated local certificate is requested (0 = disabled).
        """
        return pulumi.get(self, "auto_regenerate_days")

    @property
    @pulumi.getter(name="autoRegenerateDaysWarning")
    def auto_regenerate_days_warning(self) -> pulumi.Output[int]:
        """
        Number of days to wait before an expiry warning message is generated (0 = disabled).
        """
        return pulumi.get(self, "auto_regenerate_days_warning")

    @property
    @pulumi.getter(name="caIdentifier")
    def ca_identifier(self) -> pulumi.Output[str]:
        """
        CA identifier of the CA server for signing via SCEP.
        """
        return pulumi.get(self, "ca_identifier")

    @property
    @pulumi.getter
    def certificate(self) -> pulumi.Output[str]:
        """
        PEM format certificate.
        """
        return pulumi.get(self, "certificate")

    @property
    @pulumi.getter(name="cmpPath")
    def cmp_path(self) -> pulumi.Output[str]:
        """
        Path location inside CMP server.
        """
        return pulumi.get(self, "cmp_path")

    @property
    @pulumi.getter(name="cmpRegenerationMethod")
    def cmp_regeneration_method(self) -> pulumi.Output[str]:
        """
        CMP auto-regeneration method. Valid values: `keyupate`, `renewal`.
        """
        return pulumi.get(self, "cmp_regeneration_method")

    @property
    @pulumi.getter(name="cmpServer")
    def cmp_server(self) -> pulumi.Output[str]:
        """
        'ADDRESS:PORT' for CMP server.
        """
        return pulumi.get(self, "cmp_server")

    @property
    @pulumi.getter(name="cmpServerCert")
    def cmp_server_cert(self) -> pulumi.Output[str]:
        """
        CMP server certificate.
        """
        return pulumi.get(self, "cmp_server_cert")

    @property
    @pulumi.getter
    def comments(self) -> pulumi.Output[str]:
        """
        Comment.
        """
        return pulumi.get(self, "comments")

    @property
    @pulumi.getter
    def csr(self) -> pulumi.Output[str]:
        """
        Certificate Signing Request.
        """
        return pulumi.get(self, "csr")

    @property
    @pulumi.getter(name="enrollProtocol")
    def enroll_protocol(self) -> pulumi.Output[str]:
        """
        Certificate enrollment protocol. Valid values: `none`, `scep`, `cmpv2`.
        """
        return pulumi.get(self, "enroll_protocol")

    @property
    @pulumi.getter(name="ikeLocalid")
    def ike_localid(self) -> pulumi.Output[str]:
        """
        Local ID the FortiGate uses for authentication as a VPN client.
        """
        return pulumi.get(self, "ike_localid")

    @property
    @pulumi.getter(name="ikeLocalidType")
    def ike_localid_type(self) -> pulumi.Output[str]:
        """
        IKE local ID type. Valid values: `asn1dn`, `fqdn`.
        """
        return pulumi.get(self, "ike_localid_type")

    @property
    @pulumi.getter(name="lastUpdated")
    def last_updated(self) -> pulumi.Output[int]:
        """
        Time at which certificate was last updated.
        """
        return pulumi.get(self, "last_updated")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nameEncoding")
    def name_encoding(self) -> pulumi.Output[str]:
        """
        Name encoding method for auto-regeneration. Valid values: `printable`, `utf8`.
        """
        return pulumi.get(self, "name_encoding")

    @property
    @pulumi.getter
    def password(self) -> pulumi.Output[Optional[str]]:
        """
        Password as a PEM file.
        """
        return pulumi.get(self, "password")

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> pulumi.Output[str]:
        """
        PEM format key, encrypted with a password.
        """
        return pulumi.get(self, "private_key")

    @property
    @pulumi.getter
    def range(self) -> pulumi.Output[str]:
        """
        Either a global or VDOM IP address range for the certificate. Valid values: `global`, `vdom`.
        """
        return pulumi.get(self, "range")

    @property
    @pulumi.getter(name="scepPassword")
    def scep_password(self) -> pulumi.Output[Optional[str]]:
        """
        SCEP server challenge password for auto-regeneration.
        """
        return pulumi.get(self, "scep_password")

    @property
    @pulumi.getter(name="scepUrl")
    def scep_url(self) -> pulumi.Output[str]:
        """
        SCEP server URL.
        """
        return pulumi.get(self, "scep_url")

    @property
    @pulumi.getter
    def source(self) -> pulumi.Output[str]:
        """
        Certificate source type.
        """
        return pulumi.get(self, "source")

    @property
    @pulumi.getter(name="sourceIp")
    def source_ip(self) -> pulumi.Output[str]:
        """
        Source IP address for communications to the SCEP server.
        """
        return pulumi.get(self, "source_ip")

    @property
    @pulumi.getter
    def state(self) -> pulumi.Output[str]:
        """
        Certificate Signing Request State.
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter
    def vdomparam(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

